package tornodrom.control;

import org.hibernate.classic.Session;

import tornodrom.model.Calendaris;
import tornodrom.model.CalendarisPk;
import tornodrom.util.HibernateUtil;

import java.sql.Date;
import java.util.List;

public class CalendariManager extends HibernateUtil {

	public Calendaris find(CalendarisPk id) {
		Session session = HibernateUtil.getSessionFactory().getCurrentSession();
		session.beginTransaction();
		Calendaris calendari = (Calendaris) session.get(Calendaris.class, id);
		session.getTransaction().commit();
		return calendari;
	}
	
	public List<Calendaris> view(int idcal, Date dia) {
		Session session = HibernateUtil.getSessionFactory().getCurrentSession();
		session.beginTransaction();
		List<Calendaris> calendaris = null;
		calendaris = session.createSQLQuery("CALL CalendarisView(:idcal, :iddia)").addEntity(Calendaris.class).setParameter("idcal", idcal).setParameter("iddia", dia).list();
		session.getTransaction().commit();		
		return calendaris;		
	}	
	
	public void add(Calendaris calendari) {
		Session session = HibernateUtil.getSessionFactory().getCurrentSession();
		session.beginTransaction();
		session.save(calendari);
		session.getTransaction().commit();
	}	
	
	public void update(Calendaris calendari) {
		Session session = HibernateUtil.getSessionFactory().getCurrentSession();
		session.beginTransaction();
		session.update(calendari);
		session.getTransaction().commit();
	}	
	
	public void delete (Calendaris calendari) {
		Session session = HibernateUtil.getSessionFactory().getCurrentSession();
		session.beginTransaction();
		session.update(calendari);
		session.getTransaction().commit();		
	}
	
	public int check (int idcal, Date dataInici, Date dataFi) {
		Session session = HibernateUtil.getSessionFactory().getCurrentSession();
		session.beginTransaction();
		java.math.BigInteger chk = (java.math.BigInteger) session.createSQLQuery("CALL CalendarisGet(:idcal,:idDataI,:idDataF)").setParameter("idcal", idcal).setParameter("idDataI", dataInici).setParameter("idDataF", dataFi).uniqueResult();
		session.getTransaction().commit();
		return chk.intValue();
	}	
	
	public List<Calendaris> list (int idcal, int any) {
		Session session = HibernateUtil.getSessionFactory().getCurrentSession();
		session.beginTransaction();
		List<Calendaris> calendaris = null;
		calendaris = session.createSQLQuery("CALL CalendarisList(:idcal, :idany)").addEntity(Calendaris.class).setParameter("idcal", idcal).setParameter("idany", any).list();
		session.getTransaction().commit();		
		return calendaris;		
	}
	
	public int checkAny (int idCal, int any) {
		Session session = HibernateUtil.getSessionFactory().getCurrentSession();
		session.beginTransaction();
		java.math.BigInteger chk = (java.math.BigInteger) session.createSQLQuery("CALL CalendarisCheck(:idCal,:idAny)").setParameter("idCal", idCal).setParameter("idAny", any).uniqueResult();
		session.getTransaction().commit();
		return chk.intValue();
	}		
}
