package tornodrom.control;

import java.util.List;

import org.hibernate.HibernateException;
import org.hibernate.classic.Session;

import tornodrom.util.HibernateUtil;
import tornodrom.model.Conceptes;

public class ConceptesManager extends HibernateUtil {

	public Conceptes find(int id) {
		Session session = HibernateUtil.getSessionFactory().getCurrentSession();
		session.beginTransaction();
		Conceptes concept = (Conceptes) session.get(Conceptes.class, id);
		session.getTransaction().commit();
		return concept;
	}

	public void add(Conceptes concept) {
		Session session = HibernateUtil.getSessionFactory().getCurrentSession();
		session.beginTransaction();
		session.save(concept);
		session.getTransaction().commit();
	}		

	public void update(Conceptes concept) {
		Session session = HibernateUtil.getSessionFactory().getCurrentSession();
		session.beginTransaction();
		session.update(concept);
		session.getTransaction().commit();
	}		

	public void delete(Conceptes concept) {
		Session session = HibernateUtil.getSessionFactory().getCurrentSession();
		session.beginTransaction();
		session.update(concept);
		session.getTransaction().commit();
	}		
	
	public List<Conceptes> list() {
		Session session = HibernateUtil.getSessionFactory().getCurrentSession();
		session.beginTransaction();
		List<Conceptes> cncpt = null;
		try {
			cncpt = (List<Conceptes>)session.createSQLQuery("CALL ConceptesList()").addEntity(Conceptes.class).list();
		} catch (HibernateException e) {
			e.printStackTrace();
			session.getTransaction().rollback();
		}
		session.getTransaction().commit();
		return cncpt;
	}
}
