package tornodrom.control;

import org.hibernate.classic.Session;

import tornodrom.model.Empleats;
import tornodrom.util.HibernateUtil;

import java.util.List;

public class EmpleatManager extends HibernateUtil {

	public Empleats find(int empl) {
		Session session = HibernateUtil.getSessionFactory().getCurrentSession();
		session.beginTransaction();
		Empleats empleat = (Empleats) session.get(Empleats.class, empl);
		session.getTransaction().commit();
		return empleat;
	}	
	
	public void add(Empleats empleat) {
		Session session = HibernateUtil.getSessionFactory().getCurrentSession();
		session.beginTransaction();
		session.save(empleat);
		session.getTransaction().commit();
	}	
	
	public void update(Empleats empleat) {
		Session session = HibernateUtil.getSessionFactory().getCurrentSession();
		session.beginTransaction();
		session.update(empleat);
		session.getTransaction().commit();
	}
	
	public void delete(Empleats empleat) {
		Session session = HibernateUtil.getSessionFactory().getCurrentSession();
		session.beginTransaction();
		session.update(empleat);
		session.getTransaction().commit();
	}	
	
	public int check (String dni) {
		Session session = HibernateUtil.getSessionFactory().getCurrentSession();
		session.beginTransaction();
		java.math.BigInteger chk = (java.math.BigInteger) session.createSQLQuery("CALL EmpleatsGet(:idDni)").setParameter("idDni", dni).uniqueResult();
		session.getTransaction().commit();
		return chk.intValue();
	}
	
	public List<Empleats> list (int idEmpConn) {
		Session session = HibernateUtil.getSessionFactory().getCurrentSession();
		session.beginTransaction();
		List<Empleats> empresp = null;
		empresp = session.createSQLQuery("CALL EmpleatsList(:idEmpConn)").addEntity(Empleats.class).setParameter("idEmpConn", idEmpConn).list();
		session.getTransaction().commit();		
		return empresp;		
	}
	
	public List<Empleats> listAll () {
		Session session = HibernateUtil.getSessionFactory().getCurrentSession();
		session.beginTransaction();
		List<Empleats> empleats = null;
		empleats = session.createSQLQuery("CALL EmpleatsAll()").addEntity(Empleats.class).list();
		session.getTransaction().commit();		
		return empleats;		
	}
	
	public List<Empleats> listResp () {
		Session session = HibernateUtil.getSessionFactory().getCurrentSession();
		session.beginTransaction();
		List<Empleats> resps = null;
		resps = session.createSQLQuery("CALL ResponsablesEmpList()").addEntity(Empleats.class).list();
		session.getTransaction().commit();		
		return resps;		
	}
}
