package tornodrom.control;

import org.hibernate.classic.Session;

import tornodrom.model.Festius;
import tornodrom.util.HibernateUtil;

import java.sql.Date;
import java.util.List;

public class FestiuManager extends HibernateUtil {

	public Festius find(Date dataInici) {
		Session session = HibernateUtil.getSessionFactory().getCurrentSession();
		session.beginTransaction();
		Festius festiu = (Festius) session.get(Festius.class, dataInici);
		session.getTransaction().commit();
		return festiu;
	}

	public List<Festius> view (Date dia) {
		Session session = HibernateUtil.getSessionFactory().getCurrentSession();
		session.beginTransaction();
		List<Festius> festius = null;
		festius = session.createSQLQuery("CALL FestiusView(:iddia)").addEntity(Festius.class).setParameter("iddia", dia).list();
		session.getTransaction().commit();		
		return festius;		
	}	
	
	public void add(Festius festiu) {
		Session session = HibernateUtil.getSessionFactory().getCurrentSession();
		session.beginTransaction();
		session.save(festiu);
		session.getTransaction().commit();
	}	
	
	public void update(Festius festiu) {
		Session session = HibernateUtil.getSessionFactory().getCurrentSession();
		session.beginTransaction();
		session.update(festiu);
		session.getTransaction().commit();
	}	
	
	public void delete (Festius festes) {
		Session session = HibernateUtil.getSessionFactory().getCurrentSession();
		session.beginTransaction();
		session.update(festes);
		session.getTransaction().commit();		
	}
	
	public int check (Date dataInici, Date dataFi) {
		Session session = HibernateUtil.getSessionFactory().getCurrentSession();
		session.beginTransaction();
		java.math.BigInteger chk = (java.math.BigInteger) session.createSQLQuery("CALL FestiusGet(:idDataI,:idDataF)").setParameter("idDataI", dataInici).setParameter("idDataF", dataFi).uniqueResult();
		session.getTransaction().commit();
		return chk.intValue();
	}	
	
	public List<Festius> list (int wany) {
		Session session = HibernateUtil.getSessionFactory().getCurrentSession();
		session.beginTransaction();
		List<Festius> festius = null;
		festius = session.createSQLQuery("CALL FestiusList(:idwany)").addEntity(Festius.class).setParameter("idwany", wany).list();
		session.getTransaction().commit();		
		return festius;		
	}
}
