package tornodrom.control;

import org.hibernate.classic.Session;

import tornodrom.model.Calendaris;
import tornodrom.model.Historial;
import tornodrom.model.HistorialPk;
import tornodrom.util.HibernateUtil;

import java.sql.Date;
import java.util.List;

public class HistorialManager extends HibernateUtil {

	public Historial find (HistorialPk id) {
		Session session = HibernateUtil.getSessionFactory().getCurrentSession();
		session.beginTransaction();
		Historial hstr = (Historial) session.get(Historial.class, id);
		session.getTransaction().commit();
		return hstr;		
	}

	public List<Historial> view(int idemp, int idcal, Date dia) {
		Session session = HibernateUtil.getSessionFactory().getCurrentSession();
		session.beginTransaction();
		List<Historial> historial = null;
		historial = session.createSQLQuery("CALL HistorialView(:idemp, :idcal, :iddia)").addEntity(Historial.class).setParameter("idemp", idemp).setParameter("idcal", idcal).setParameter("iddia", dia).list();
		session.getTransaction().commit();		
		return historial;		
	}	
	
	public List<Historial> list (int idEmp) {
		Session session = HibernateUtil.getSessionFactory().getCurrentSession();
		session.beginTransaction();
		List<Historial> historial = null;
		historial = session.createSQLQuery("CALL HistorialList(:idemp)").addEntity(Historial.class).setParameter("idemp", idEmp).list();
		session.getTransaction().commit();		
		return historial;		
	}

	public void add(Historial historial) {
		Session session = HibernateUtil.getSessionFactory().getCurrentSession();
		session.beginTransaction();
		session.save(historial);
		session.getTransaction().commit();
	}	
	
	public void update(Historial historial) {
		Session session = HibernateUtil.getSessionFactory().getCurrentSession();
		session.beginTransaction();
		session.update(historial);
		session.getTransaction().commit();
	}	
	
	public List<Historial> listAny (int idEmp, int idAny) {
		Session session = HibernateUtil.getSessionFactory().getCurrentSession();
		session.beginTransaction();
		List<Historial> historial = null;
		historial = session.createSQLQuery("CALL HistorialAny(:idemp, :idany)").addEntity(Historial.class).setParameter("idemp", idEmp).setParameter("idany", idAny).list();
		session.getTransaction().commit();		
		return historial;		
	}
	
	public List<Calendaris> listTorns (int idCal, Date idFini, Date idFfin) {
		Session session = HibernateUtil.getSessionFactory().getCurrentSession();
		session.beginTransaction();
		List<Calendaris> calendari = null;
		calendari = session.createSQLQuery("CALL HistorialTorns(:idcal, :idfini, :idffin)").addEntity(Calendaris.class).setParameter("idcal", idCal).setParameter("idfini", idFini).setParameter("idffin", idFfin).list();
		session.getTransaction().commit();		
		return calendari;		
	}
	
	public int check (int idemp, Date dataInici, Date dataFi) {
		Session session = HibernateUtil.getSessionFactory().getCurrentSession();
		session.beginTransaction();
		java.math.BigInteger chk = (java.math.BigInteger) session.createSQLQuery("CALL HistorialGet(:idemp,:idDataI,:idDataF)").setParameter("idemp", idemp).setParameter("idDataI", dataInici).setParameter("idDataF", dataFi).uniqueResult();
		session.getTransaction().commit();
		return chk.intValue();
	}	
}
