package tornodrom.control;

import org.hibernate.classic.Session;

import tornodrom.model.Incidencies;
import tornodrom.model.IncidenciesPk;
import tornodrom.util.HibernateUtil;

import java.sql.Date;
import java.util.List;

public class IncidenciaManager extends HibernateUtil {

	public Incidencies find (IncidenciesPk id) {
		Session session = HibernateUtil.getSessionFactory().getCurrentSession();
		session.beginTransaction();
		Incidencies inc = (Incidencies) session.get(Incidencies.class, id);
		session.getTransaction().commit();
		return inc;		
	}

	public List<Incidencies> view(int idemp, Date dia) {
		Session session = HibernateUtil.getSessionFactory().getCurrentSession();
		session.beginTransaction();
		List<Incidencies> incs = null;
		incs = session.createSQLQuery("CALL IncidenciaView(:idemp, :iddia)").addEntity(Incidencies.class).setParameter("idemp", idemp).setParameter("iddia", dia).list();
		session.getTransaction().commit();		
		return incs;		
	}	
	
	public List<Incidencies> list (int idEmp) {
		Session session = HibernateUtil.getSessionFactory().getCurrentSession();
		session.beginTransaction();
		List<Incidencies> incs = null;
		incs = session.createSQLQuery("CALL IncidenciaList(:idemp)").addEntity(Incidencies.class).setParameter("idemp", idEmp).list();
		session.getTransaction().commit();		
		return incs;		
	}

	public void add(Incidencies incidencia) {
		Session session = HibernateUtil.getSessionFactory().getCurrentSession();
		session.beginTransaction();
		session.save(incidencia);
		session.getTransaction().commit();
	}	
	
	public void update(Incidencies incidencia) {
		Session session = HibernateUtil.getSessionFactory().getCurrentSession();
		session.beginTransaction();
		session.update(incidencia);
		session.getTransaction().commit();
	}	
	
	public List<Incidencies> listAny (int idEmp, int idAny) {
		Session session = HibernateUtil.getSessionFactory().getCurrentSession();
		session.beginTransaction();
		List<Incidencies> incs = null;
		incs = session.createSQLQuery("CALL IncidenciesAny(:idemp, :idany)").addEntity(Incidencies.class).setParameter("idemp", idEmp).setParameter("idany", idAny).list();
		session.getTransaction().commit();		
		return incs;		
	}
	
	public int check (int idemp, Date dataInici, Date dataFi) {
		Session session = HibernateUtil.getSessionFactory().getCurrentSession();
		session.beginTransaction();
		java.math.BigInteger chk = (java.math.BigInteger) session.createSQLQuery("CALL IncidenciaGet(:idemp,:idDataI,:idDataF)").setParameter("idemp", idemp).setParameter("idDataI", dataInici).setParameter("idDataF", dataFi).uniqueResult();
		session.getTransaction().commit();
		return chk.intValue();
	}	
}
