package tornodrom.control;

import org.hibernate.classic.Session;

import tornodrom.model.Responsables;
import tornodrom.model.ResponsablesPk;
import tornodrom.util.HibernateUtil;

import java.sql.Date;
import java.util.List;

public class ResponsableManager extends HibernateUtil {

	public List<Responsables> list (int idEmp) {
		Session session = HibernateUtil.getSessionFactory().getCurrentSession();
		session.beginTransaction();
		List<Responsables> resps = null;
		resps = session.createSQLQuery("CALL ResponsablesList(:idemp)").addEntity(Responsables.class).setParameter("idemp", idEmp).list();
		session.getTransaction().commit();		
		return resps;		
	}

	public Responsables find(ResponsablesPk id) {
		Session session = HibernateUtil.getSessionFactory().getCurrentSession();
		session.beginTransaction();
		Responsables resp = (Responsables) session.get(Responsables.class, id);
		session.getTransaction().commit();
		return resp;
	}
	
	public void add(Responsables responsable) {
		Session session = HibernateUtil.getSessionFactory().getCurrentSession();
		session.beginTransaction();
		session.save(responsable);
		session.getTransaction().commit();
	}	
	
	public void update(Responsables resp) {
		Session session = HibernateUtil.getSessionFactory().getCurrentSession();
		session.beginTransaction();
		session.update(resp);
		session.getTransaction().commit();
	}	
	
	public int check (int idemp, Date dataInici, Date dataFi) {
		Session session = HibernateUtil.getSessionFactory().getCurrentSession();
		session.beginTransaction();
		java.math.BigInteger chk = (java.math.BigInteger) session.createSQLQuery("CALL HistorialGet(:idemp,:idDataI,:idDataF)").setParameter("idemp", idemp).setParameter("idDataI", dataInici).setParameter("idDataF", dataFi).uniqueResult();
		session.getTransaction().commit();
		return chk.intValue();
	}	
	
	public List<Responsables> ultim (int idemp) {
		Session session = HibernateUtil.getSessionFactory().getCurrentSession();
		session.beginTransaction();
		List<Responsables> lastresp = null;
		lastresp = session.createSQLQuery("CALL ResponsablesUlt(:idemp)").addEntity(Responsables.class).setParameter("idemp", idemp).list();
		session.getTransaction().commit();		
		return lastresp;		
	}
}
