package tornodrom.control;

import java.util.List;

import org.hibernate.HibernateException;
import org.hibernate.classic.Session;

import tornodrom.util.HibernateUtil;
import tornodrom.model.TipusCalendaris;

public class TipuscalendariManager extends HibernateUtil {

	public TipusCalendaris find(int id) {
		Session session = HibernateUtil.getSessionFactory().getCurrentSession();
		session.beginTransaction();
		TipusCalendaris tcal = (TipusCalendaris) session.get(TipusCalendaris.class, id);
		session.getTransaction().commit();
		return tcal;
	}

	public void add(TipusCalendaris tcal) {
		Session session = HibernateUtil.getSessionFactory().getCurrentSession();
		session.beginTransaction();
		session.save(tcal);
		session.getTransaction().commit();
	}		

	public void update(TipusCalendaris tcal) {
		Session session = HibernateUtil.getSessionFactory().getCurrentSession();
		session.beginTransaction();
		session.update(tcal);
		session.getTransaction().commit();
	}		

	public void delete(TipusCalendaris tcal) {
		Session session = HibernateUtil.getSessionFactory().getCurrentSession();
		session.beginTransaction();
		session.update(tcal);
		session.getTransaction().commit();
	}		
	
	public List<TipusCalendaris> list() {
		Session session = HibernateUtil.getSessionFactory().getCurrentSession();
		session.beginTransaction();
		List<TipusCalendaris> ctcal = null;
		try {
			ctcal = (List<TipusCalendaris>)session.createSQLQuery("CALL TipuscalendarisList()").addEntity(TipusCalendaris.class).list();
		} catch (HibernateException e) {
			e.printStackTrace();
			session.getTransaction().rollback();
		}
		session.getTransaction().commit();
		return ctcal;
	}
}
