package tornodrom.model;

import java.io.Serializable;
import java.sql.Date;
import java.sql.Timestamp;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.OneToOne;
import javax.persistence.Table;

@Entity
@Table(name="empleats")
public class Empleats implements Serializable {

	/**
	 * 
	 */
	private static final long serialVersionUID = 2463750235116963879L;

	/**
	 * 
	 */
	private int idEmpleat;
	private String nom;
	private String pCognom;
	private String sCognom;
	private int idIdentificatiu;
	private Identificatius dIdentificatiu;
	private String nIdentificacio;
	private String telefon;
	private String correu;
	private Date dataNaixament;
	private Date dataIncorporacio;
	private Date dataBaixa;
	private String usuariAlta;
	private Timestamp tmstmpAlta;
	private String usuariModi;
	private Timestamp tmstmpModi;
	private String usuariBaja;
	private Timestamp tmstmpBaja;	
	
	@Id
	@GeneratedValue
	@Column(name="idEmpleat")	
	public int getIdEmpleat() {
		return idEmpleat;
	}
	@Column(name="nom")
	public String getNom() {
		return nom;
	}
	@Column(name="pCognom")
	public String getPCognom() {
		return pCognom;
	}	
	@Column(name="sCognom")
	public String getSCognom() {
		return sCognom;
	}
	@OneToOne(cascade=CascadeType.ALL)
	@JoinColumn(name="tIdentificacio")
	public Identificatius getDIdentificatiu(){
		return dIdentificatiu;
	}
	@Column(name="nIdentificacio")
	public String getNIdentificacio() {
		return nIdentificacio;
	}
	@Column(name="telefon")
	public String getTelefon() {
		return telefon;
	}	
	@Column(name="correu")
	public String getCorreu() {
		return correu;
	}	
	@Column(name="dataNaixament")
	public Date getDataNaixament() {
		return dataNaixament;
	}	
	@Column(name="dataIncorporacio")
	public Date getDataIncorporacio() {
		return dataIncorporacio;
	}		
	@Column(name="dataBaixa")
	public Date getDataBaixa() {
		return dataBaixa;
	}
	@Column(name="usuariAlta")
	public String getUsuariAlta() {
		return usuariAlta;
	}	
	@Column(name="tmstmpAlta")
	public Timestamp getTmstmpAlta() {
		return tmstmpAlta;
	}	
	@Column(name="usuariModi")
	public String getUsuariModi() {
		return usuariModi;
	}	
	@Column(name="tmstmpModi")
	public Timestamp getTmstmpModi() {
		return tmstmpModi;
	}		
	@Column(name="usuariBaja")
	public String getUsuariBaja() {
		return usuariBaja;
	}	
	@Column(name="tmstmpBaja")
	public Timestamp getTmstmpBaja() {
		return tmstmpBaja;
	}		
	
	public void setIdEmpleat(int idEmpleat) {
		this.idEmpleat = idEmpleat;
	}
	public void setNom(String nom) {
		this.nom = nom;
	}
	public void setPCognom(String pCognom) {
		this.pCognom = pCognom;
	}	
	public void setSCognom(String sCognom) {
		this.sCognom = sCognom;
	}
	public void setIdIdentificatiu(int idIdentificatiu) {
		this.idIdentificatiu = idIdentificatiu;
	}
	public void setDIdentificatiu(Identificatius dIdentificatiu) {
		this.dIdentificatiu = dIdentificatiu;
	}
	public void setNIdentificacio(String nIdentificacio) {
		this.nIdentificacio = nIdentificacio;
	}
	public void setTelefon(String telefon) {
		this.telefon = telefon;
	}	
	public void setCorreu(String correu) {
		this.correu = correu;
	}
	public void setDataNaixament(Date dataNaixament) {
		this.dataNaixament = dataNaixament;
	}	
	public void setDataIncorporacio(Date dataIncorporacio) {
		this.dataIncorporacio = dataIncorporacio;
	}		
	public void setDataBaixa(Date dataBaixa) {
		this.dataBaixa = dataBaixa;
	}
	public void setUsuariAlta(String usuariAlta) {
		this.usuariAlta = usuariAlta;
	}	
	public void setTmstmpAlta(Timestamp tmstmpAlta) {
		this.tmstmpAlta = tmstmpAlta;
	}	
	public void setUsuariModi(String usuariModi) {
		this.usuariModi = usuariModi;
	}	
	public void setTmstmpModi(Timestamp tmstmpModi) {
		this.tmstmpModi = tmstmpModi;
	}	
	public void setUsuariBaja(String usuariBaja) {
		this.usuariBaja = usuariBaja;
	}	
	public void setTmstmpBaja(Timestamp tmstmpBaja) {
		this.tmstmpBaja = tmstmpBaja;
	}			
}
