package tornodrom.model;

import java.io.Serializable;
import java.sql.Date;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Embeddable;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;

@Embeddable
public class ResponsablesPk implements Serializable {

	/**
	 * 
	 */
	private static final long serialVersionUID = -2638081677529317123L;

	/**
	 * 
	 */
	private int idEmpleat;
	private Empleats dEmpleat;
	private int idResponsable;
	private Empleats dResponsable;
	private Date dataInici;

	public ResponsablesPk() {
		
	}
	
	public ResponsablesPk(int idEmpleat,int idResponsable, Date dataInici){
		this.idEmpleat = idEmpleat;
		this.idResponsable = idResponsable;
		this.dataInici = dataInici;
	}

	@ManyToOne(cascade = CascadeType.ALL)	
	@JoinColumn(name="empleat")
	public Empleats getDEmpleat(){
		return dEmpleat;
	}	
	@ManyToOne(cascade = CascadeType.ALL)	
	@JoinColumn(name="responsable")
	public Empleats getDResponsable(){
		return dResponsable;
	}	
	@Column(name="dataInici")
	public Date getDataInici() {
		return dataInici;
	}

	public void setIdEmpleat(int idEmpleat) {
		this.idEmpleat = idEmpleat;
	}	
	public void setDEmpleat(Empleats dEmpleat) {
		this.dEmpleat = dEmpleat;
	}
	public void setIdResponsable(int idResponsable) {
		this.idResponsable = idResponsable;
	}
	public void setDResponsable(Empleats dResponsable) {
		this.dResponsable = dResponsable;
	}	
	public void setDataInici(Date dataInici) {
		this.dataInici = dataInici;
	}
}
