package tornodrom.view;

import java.util.Date;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.List;
import java.util.Map;

import tornodrom.control.EmpleatManager;
import tornodrom.control.FestiuManager;
import tornodrom.control.HistorialManager;
import tornodrom.control.TipuscalendariManager;
import tornodrom.control.TipustornManager;
import tornodrom.list.EmpleatsTab;
import tornodrom.list.HistorialTab;
import tornodrom.model.Calendaris;
import tornodrom.model.Empleats;
import tornodrom.model.Festius;
import tornodrom.model.Historial;
import tornodrom.model.HistorialPk;
import tornodrom.model.TipusCalendaris;

import com.opensymphony.xwork2.ActionSupport;
import com.opensymphony.xwork2.ActionContext;

public class CempleaAction extends ActionSupport {

	private int id;
	
	private EmpleatManager linkEmpleat;
	private List<Empleats> cempleaList;
	ArrayList<EmpleatsTab> lista;
	private List cempleaDisp = new ArrayList();

	private Map session;
	
	private Empleats empleat;
	private String vnom;
	private String vpcg;
	private String vscg;
	private String vide;
	private String vnif;
	private String vtel;
	private String vcor;
	private Date vdna;
	private Date vdin;
	private Date vdba;

	private String idEmp;
	private Calendar workany;
	private int any;
	
	private HistorialManager linkHistorial;
	private List<Historial> historialList;
	ArrayList<HistorialTab> hlista;
	private List historialDisp = new ArrayList();
	
	private List<Calendaris> calendariList;
	private Calendar cmpini;
	private Calendar cmpfin;
	private Calendar wrkini;
	private Calendar wrkfin;
	private int[] wtcl = new int [366];
	private int[] wtrn = new int [366];
	private String [] dtrn = new String [366];
	private String [] dcolor = new String [366];
	private int[] wfst = new int [366];
	private String [] dfst = new String [366];
	private String [] fcolor = new String [366];
	private String almanaque;
	private String[] posx = new String [12];
	private String[] posy = new String [12];
	private String[] tit = new String [12];
	private String[] sem = new String [8];
	
	private TipuscalendariManager linkTcal;
	private List<TipusCalendaris> tcalList;
	private int tc;
	private int tt;
	private String df;
	private Date fdataini;
	private Date fdatafin;
	private String ftcal;
	private TipustornManager linkTtorn;
	private String fttrn;	

	private int ftcalid;
	private String ftcalds;	
	
	private FestiuManager linkFestiu;
	private List<Festius> festiuList;
	private Historial histor;
	private HistorialPk historPk;	
	
	public CempleaAction() {
		linkEmpleat = new EmpleatManager();
		linkHistorial = new HistorialManager();
		linkTcal = new TipuscalendariManager();
		linkFestiu = new FestiuManager();
		linkTtorn = new TipustornManager();
		session = ActionContext.getContext().getSession();
		cmpini = Calendar.getInstance();
		cmpfin = Calendar.getInstance();
		wrkini = Calendar.getInstance();
		wrkfin = Calendar.getInstance();
	}	
	
	public String execute() {
		return SUCCESS;
	}
	
	public String tornar() {
		return SUCCESS;
	}
	
	public String tornarD() {
		return SUCCESS;
	}
	
	public String llista() {
		this.cempleaList = linkEmpleat.list(((Integer)session.get("xidempl")).intValue());
		for (int iter = 0; iter < this.cempleaList.size(); iter++) {
			this.cempleaDisp.add(
					new EmpleatsTab(
							this.cempleaList.get(iter).getIdEmpleat(), 
							this.cempleaList.get(iter).getNIdentificacio(),
							this.cempleaList.get(iter).getNom() + " " +
							this.cempleaList.get(iter).getPCognom() + " " +
							this.cempleaList.get(iter).getSCognom(),
							this.cempleaList.get(iter).getTelefon(),
							this.cempleaList.get(iter).getCorreu(),
							this.cempleaList.get(iter).getDataIncorporacio(),
							this.cempleaList.get(iter).getDataBaixa(),
							"<a href=\"cempleaS?id=" + this.cempleaList.get(iter).getIdEmpleat()
							+ "\">" + getText("cemplea.tbl.detall") + "</a> | " +
							"<a href=\"cempleaH?id=" + this.cempleaList.get(iter).getIdEmpleat()
							+ "\">" + getText("cemplea.tbl.calend") + "</a>"
			));
		}
		return SUCCESS;		
	}
	
	public String ver() {
		empleat = linkEmpleat.find(getId());
		setVnom(empleat.getNom());
		setVpcg(empleat.getPCognom());
		setVscg(empleat.getSCognom());
		setVide(empleat.getDIdentificatiu().getDescripcio());
		setVnif(empleat.getNIdentificacio());
		setVtel(empleat.getTelefon());
		setVcor(empleat.getCorreu());
		setVdna(empleat.getDataNaixament());
		setVdin(empleat.getDataIncorporacio());
		setVdba(empleat.getDataBaixa());
		return SUCCESS;		
	}

	public String detall() {
		if (getId() == 0) {
			setId((Integer)session.get("xidcalemp"));
			setIdEmp((String)session.get("xnomcalemp"));
		}
		// Any actual el que treballem		
		if (session.get("xworkany") == null) {
			workany = Calendar.getInstance();
		} else {
			workany = (Calendar)session.get("xworkany");			
		}
		setAny(workany.get(Calendar.YEAR));

		wtrn = new int [366];
		dtrn = new String [366];	
		dcolor = new String [366];	
		String wini = "01-01-" + workany.get(Calendar.YEAR);
		String wfin = "31-12-" + workany.get(Calendar.YEAR);		
		SimpleDateFormat sdwini= new SimpleDateFormat("dd-MM-yyyy"); 
		SimpleDateFormat sdwfin= new SimpleDateFormat("dd-MM-yyyy"); 
		
		// Recuperem llista amb historial
		this.historialList = linkHistorial.listAny(getId(), getAny());
		for (int iter = 0; iter < this.historialList.size(); iter++) {
			try {
				cmpini.setTime(sdwini.parse(wini));
				cmpfin.setTime(sdwfin.parse(wfin));
				wrkini.setTime(this.historialList.get(iter).getId().getDataInici());
				if (this.historialList.get(iter).getDataFi() == null) {
					wrkfin = cmpfin;				
				} else {
					wrkfin.setTime(this.historialList.get(iter).getDataFi());
				}
			} catch (ParseException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			if (cmpini.getTime().after(wrkini.getTime())) wrkini = cmpini;
			if (cmpfin.getTime().before(wrkfin.getTime())) wrkfin = cmpfin;
			this.calendariList = linkHistorial.listTorns(
					this.historialList.get(iter).getId().getDCalendari().getIdTCalendari(), 
					new java.sql.Date(wrkini.getTime().getTime()), 
					new java.sql.Date(wrkfin.getTime().getTime())
			);
			for (int i=0;i<calendariList.size();i++){
				//				Prepara les dades
				Calendar cini = Calendar.getInstance();
				Calendar cfin = Calendar.getInstance();
				cini.setTime(calendariList.get(i).getId().getDataInici());
				if (cini.getTime().before(wrkini.getTime())) cini = wrkini;
				cfin.setTime(calendariList.get(i).getDataFi());
				if (cfin.getTime().after(wrkfin.getTime())) cfin = wrkfin;
				Calendar c = cini;
				while (! c.getTime().after(cfin.getTime())){
					wtcl[c.get(Calendar.DAY_OF_YEAR) - 1] = calendariList.get(i).getId().getDCalendari().getIdTCalendari();
					wtrn[c.get(Calendar.DAY_OF_YEAR) - 1] = calendariList.get(i).getDTTorn().getIdTTorn();
					dtrn[c.get(Calendar.DAY_OF_YEAR) - 1] = calendariList.get(i).getDTTorn().getDescripcio();
					dcolor[c.get(Calendar.DAY_OF_YEAR) - 1] = calendariList.get(i).getDTTorn().getColor();				
					c.add(Calendar.DATE, 1);	
				}
			}
		}
		// Recuperem llista amb els festius del any i carreguem
		this.festiuList = linkFestiu.list(getAny());
		setWfest();
		// Generem calendari		
		this.setAlmanaque(almanaque(workany));
		
		// Mantenim any i empleat
		session.put("xalmanaque", almanaque);
		session.put("xworkany", workany);
		session.put("xidcalemp",getId());
		empleat = linkEmpleat.find(getId());
		setIdEmp(empleat.getNom()+" "+empleat.getPCognom());
		session.put("xnomcalemp",getIdEmp());
		return SUCCESS;
	}
	
	public String preview() {
		historialDisp = new ArrayList();
		setId((Integer)session.get("xidcalemp"));
		setIdEmp((String)session.get("xnomcalemp"));
		workany = (Calendar)session.get("xworkany");			
		setAny(workany.get(Calendar.YEAR));
		// Recuperem llista amb historial
		this.historialList = linkHistorial.list(getId());
		for (int iter = 0; iter < this.historialList.size(); iter++) {
			this.historialDisp.add(
					new HistorialTab(
							this.historialList.get(iter).getId().getDCalendari().getIdTCalendari(),
							this.historialList.get(iter).getId().getDCalendari().getDescripcio(),
							this.historialList.get(iter).getId().getDataInici(),
							this.historialList.get(iter).getDataFi(),
							null
			));
		}			
		return SUCCESS;
	}
	public String restar() {
		workany = (Calendar)session.get("xworkany");
		workany.add(Calendar.YEAR, -1);

		session.put("xalmanaque", almanaque);
		session.put("xworkany", workany);
		return SUCCESS;
	}	
	public String sumar() {
		workany = (Calendar)session.get("xworkany");
		workany.add(Calendar.YEAR, 1);

		session.put("xalmanaque", almanaque);
		session.put("xworkany", workany);
		return SUCCESS;
	}		
	
	public String ver_bis() {
		// Obtenir llista tipus torns
		tcalList = linkTcal.list();
		workany = (Calendar)session.get("xworkany");			
		setAny(workany.get(Calendar.YEAR));	
		setId((Integer)session.get("xidcalemp"));
		setIdEmp((String)session.get("xnomcalemp"));
		SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
		try {
			Date d = sdf.parse(getDf());
			histor = linkHistorial.view(getId(), getTc(), new java.sql.Date(d.getTime())).get(0);
			setFdataini(histor.getId().getDataInici());
			setFdatafin(histor.getDataFi());
			setFtcal(histor.getId().getDCalendari().getDescripcio());
			setFtcalid(histor.getId().getDCalendari().getIdTCalendari());
			setFtcalds(histor.getId().getDCalendari().getDescripcio());
			if (getTt() != 0) setFttrn(linkTtorn.find(getTt()).getDescripcio());
			session.put("xtcalid", ftcalid);
			return SUCCESS;
		} catch (ParseException ex) {
			ex.printStackTrace();
			return ERROR;
		}			
	}
	
	public int getId() {
		return id;
	}
	public List<EmpleatsTab> getCempleaDisp() {
		return cempleaDisp;
	}	
	public String getVnom() {
		return vnom;
	}
	public String getVpcg() {
		return vpcg;
	}
	public String getVscg() {
		return vscg;
	}
	public String getVide() {
		return vide;
	}
	public String getVnif() {
		return vnif;
	}
	public String getVtel() {
		return vtel;
	}
	public String getVcor() {
		return vcor;
	}
	public Date getVdna() {
		return vdna;
	}
	public Date getVdin() {
		return vdin;
	}
	public Date getVdba() {
		return vdba;
	}
	public String getIdEmp() {
		return idEmp;
	}
	public int getAny() {
		return any;
	}
	public List<HistorialTab> getHistorialDisp() {
		return historialDisp;
	}	
	public String getAlmanaque() {
		return almanaque;
	}
	public int getTc() {
		return tc;
	}
	public int getTt() {
		return tt;
	}	
	public String getDf() {
		return df;
	}
	public Date getFdataini() {
		return fdataini;
	}
	public Date getFdatafin() {
		return fdatafin;
	}	
	public String getFtcal() {
		return ftcal;
	}
	public String getFttrn() {
		return fttrn;
	}
	public List<TipusCalendaris> getTcalList() {
		return tcalList;
	}
	public int getFtcalid() {
		return ftcalid;
	}
	public String getFtcalds() {
		return ftcalds;
	}	

	public void setId(int id) {
		this.id = id;
	}
	public void setCempleaDisp(List<EmpleatsTab> cempleaDisp) {
		this.cempleaDisp = cempleaDisp;
	}
	public void setVnom(String vnom) {
		this.vnom = vnom;
	}
	public void setVpcg(String vpcg) {
		this.vpcg = vpcg;
	}
	public void setVscg(String vscg) {
		this.vscg = vscg;
	}
	public void setVide(String vide) {
		this.vide = vide;
	}
	public void setVnif(String vnif) {
		this.vnif = vnif;
	}
	public void setVtel(String vtel) {
		this.vtel = vtel;
	}
	public void setVcor(String vcor) {
		this.vcor = vcor;
	}
	public void setVdna(Date vdna) {
		this.vdna = vdna;
	}
	public void setVdin(Date vdin) {
		this.vdin = vdin;
	}
	public void setVdba(Date vdba) {
		this.vdba = vdba;
	}
	public void setIdEmp(String idEmp) {
		this.idEmp = idEmp;
	}
	public void setAny(int any) {
		this.any = any;
	}
	public void setHistorialDisp(List<HistorialTab> historialDisp) {
		this.historialDisp = historialDisp;
	}
	public void setAlmanaque(String almanaque) {
		this.almanaque = almanaque;
	}
	public void setTc(int tc) {
		this.tc = tc;
	}	
	public void setTt(int tt) {
		this.tt = tt;
	}		
	public void setDf(String df) {
		this.df = df;
	}
	public void setFdataini(Date fdataini) {
		this.fdataini = fdataini;
	}	
	public void setFdatafin(Date fdatafin) {
		this.fdatafin = fdatafin;
	}	
	public void setFtcal(String ftcal) {
		this.ftcal = ftcal;
	}
	public void setFttrn(String fttrn) {
		this.fttrn = fttrn;
	}
	public void setTcalList(List<TipusCalendaris> tcalList) {
		this.tcalList = tcalList;
	}	
	public void setFtcalid(int ftcalid) {
		this.ftcalid = ftcalid;
	}
	public void setFtcalds(String ftcalds) {
		this.ftcalds = ftcalds;
	}
	
	public void setWfest() {
		wfst = new int [366];
		dfst = new String [366];	
  		fcolor = new String [366];	
		for (int i=0;i<festiuList.size();i++){
//			Prepara les dades
			Calendar cini = Calendar.getInstance();
			Calendar cfin = Calendar.getInstance();
			cini.setTime(festiuList.get(i).getDataInici());
			cfin.setTime(festiuList.get(i).getDataFi());
			Calendar c = cini;
			while (! c.getTime().after(cfin.getTime())){
				wfst[c.get(Calendar.DAY_OF_YEAR) - 1] = festiuList.get(i).getDTFestiu().getIdTFestiu();
				dfst[c.get(Calendar.DAY_OF_YEAR) - 1] = festiuList.get(i).getDTFestiu().getDescripcio();
				fcolor[c.get(Calendar.DAY_OF_YEAR) - 1] = festiuList.get(i).getDTFestiu().getColor();				
				c.add(Calendar.DATE, 1);	
			}
		}
	}
	
	public String almanaque(Calendar work){
		this.almanaque = "";
		setPos();
		int omes = -1;
		int oweek = 0;
		String wini = "01-01-" + work.get(Calendar.YEAR);
		String wfin = "31-12-" + work.get(Calendar.YEAR);		
		SimpleDateFormat sdwini= new SimpleDateFormat("dd-MM-yyyy"); 
		SimpleDateFormat sdwfin= new SimpleDateFormat("dd-MM-yyyy"); 
		try {
//			Prepara les dades
			Calendar cini = Calendar.getInstance();
			Calendar cfin = Calendar.getInstance();			
			cini.setTime(sdwini.parse(wini));
			cfin.setTime(sdwfin.parse(wfin));
			Calendar c = cini;
			while (! c.getTime().after(cfin.getTime())){
				// Canvi de mes
				if (omes != c.get(Calendar.MONTH)) {
					if (omes != -1) {
						switch (c.get(Calendar.DAY_OF_WEEK)){
						case 3: this.almanaque = this.almanaque + "<td></td><td></td><td></td><td></td><td></td><td></td>"; break;
						case 4: this.almanaque = this.almanaque + "<td></td><td></td><td></td><td></td><td></td>";  break;
						case 5: this.almanaque = this.almanaque + "<td></td><td></td><td></td><td></td>";  break;
						case 6: this.almanaque = this.almanaque + "<td></td><td></td><td></td>";  break;
						case 7: this.almanaque = this.almanaque + "<td></td><td></td>";  break;
						case 1: this.almanaque = this.almanaque + "<td></td>";  break;
						}
						this.almanaque = this.almanaque + "</tr>\n</table>\n";
					}
					// nova taula
					this.almanaque = this.almanaque + "<table style=\"font-family:Calibri; font-size:12px;position: absolute;left:" + this.posx[c.get(Calendar.MONTH)]+";top:" + this.posy[c.get(Calendar.MONTH)]+";\">\n";
					// capalera
					this.almanaque = this.almanaque + "<tr><th align=center colspan=8>" + getText(tit[c.get(Calendar.MONTH)])+"</th></tr>\n";
					this.almanaque = this.almanaque + "<tr><td style=\"color:#FE9A2E;\">" + getText(sem[0]) + "</td><td style=\"color:#0101DF;\">" + getText(sem[1]) + "</td><td style=\"color:#0101DF;\">" + getText(sem[2]) + "</td><td style=\"color:#0101DF;\">" + getText(sem[3]) + "</td><td style=\"color:#0101DF;\">" + getText(sem[4]) + "</td><td style=\"color:#0101DF;\">" + getText(sem[5]) + "</td><td style=\"color:#0101DF;\">" + getText(sem[6]) + "</td><td style=\"color:#0101DF;\">" + getText(sem[7]) + "</td></tr>\n";
					omes = c.get(Calendar.MONTH);
					// provoquem un canvi de setmana
					oweek = 0;
				}
//				Canvi de setmana
				if (oweek != c.get(Calendar.WEEK_OF_YEAR)) {
					if (oweek != 0) this.almanaque = this.almanaque + "</tr>\n";
					switch (c.get(Calendar.DAY_OF_WEEK)){
					case 2: this.almanaque = this.almanaque + "<tr><td align=\"right\" style=\"color:#FF8000;\">" + c.get(Calendar.WEEK_OF_YEAR) + "</td>"; break;
					case 3: this.almanaque = this.almanaque + "<tr><td align=\"right\" style=\"color:#FF8000;\">" + c.get(Calendar.WEEK_OF_YEAR) + "</td><td></td>"; break;
					case 4: this.almanaque = this.almanaque + "<tr><td align=\"right\" style=\"color:#FF8000;\">" + c.get(Calendar.WEEK_OF_YEAR) + "</td><td></td><td></td>"; break;					
					case 5: this.almanaque = this.almanaque + "<tr><td align=\"right\" style=\"color:#FF8000;\">" + c.get(Calendar.WEEK_OF_YEAR) + "</td><td></td><td></td><td></td>"; break;
					case 6: this.almanaque = this.almanaque + "<tr><td align=\"right\" style=\"color:#FF8000;\">" + c.get(Calendar.WEEK_OF_YEAR) + "</td><td></td><td></td><td></td><td></td>"; break;	
					case 7: this.almanaque = this.almanaque + "<tr><td align=\"right\" style=\"color:#FF8000;\">" + c.get(Calendar.WEEK_OF_YEAR) + "</td><td></td><td></td><td></td><td></td><td></td>"; break;					
					case 1: this.almanaque = this.almanaque + "<tr><td align=\"right\" style=\"color:#FF8000;\">" + c.get(Calendar.WEEK_OF_YEAR) + "</td><td></td><td></td><td></td><td></td><td></td><td></td>"; break;
					}
					oweek = c.get(Calendar.WEEK_OF_YEAR);					
				}
				if (wtrn[c.get(Calendar.DAY_OF_YEAR) - 1] != 0) {
					if (wfst[c.get(Calendar.DAY_OF_YEAR) - 1] != 0) {
						SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
						this.almanaque = this.almanaque + "<td bgcolor=\"" + 
							dcolor[c.get(Calendar.DAY_OF_YEAR) - 1] + "\"  title = \"" + 
							dtrn[c.get(Calendar.DAY_OF_YEAR) - 1] + " - " + dfst[c.get(Calendar.DAY_OF_YEAR) - 1] + 
							"\" align=\"right\" " + 
							"onclick=\"document.location.href = 'cempleaD?tc=" + wtcl[c.get(Calendar.DAY_OF_YEAR) - 1] +
							"&tt=" + wtrn[c.get(Calendar.DAY_OF_YEAR) - 1] +
							"&df=" + sdf.format(c.getTime())+ "'\" style=\"border: solid 0 #000; border-bottom-width:2px; cursor:pointer\">" + 
							c.get(Calendar.DAY_OF_MONTH)+ "</td>";						
					} else {
						SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
						this.almanaque = this.almanaque + "<td bgcolor=\"" + 
							dcolor[c.get(Calendar.DAY_OF_YEAR) - 1] + "\"  title = \"" + 
							dtrn[c.get(Calendar.DAY_OF_YEAR) - 1] + "\" align=\"right\" " + 
							"onclick=\"document.location.href = 'cempleaD?tc=" + wtcl[c.get(Calendar.DAY_OF_YEAR) - 1] +
							"&tt=" + wtrn[c.get(Calendar.DAY_OF_YEAR) - 1] +
							"&df=" + sdf.format(c.getTime())+ "'\" style=\"cursor:pointer\">" + 
							c.get(Calendar.DAY_OF_MONTH)+ "</td>";
					}
				} else {
					if (wfst[c.get(Calendar.DAY_OF_YEAR) - 1] != 0) {
						this.almanaque = this.almanaque + "<td bgcolor=\"" + 
							fcolor[c.get(Calendar.DAY_OF_YEAR) - 1] + "\"  title = \"" + 
							dfst[c.get(Calendar.DAY_OF_YEAR) - 1] + "\" align=\"right\">" + 
							c.get(Calendar.DAY_OF_MONTH)+ "</td>";						
					} else {
						this.almanaque = this.almanaque + "<td align=\"right\">" + c.get(Calendar.DAY_OF_MONTH)+ "</td>";
					}
				}
				c.add(Calendar.DATE, 1);
			}
			switch (c.get(Calendar.DAY_OF_WEEK)){
			case 3: this.almanaque = this.almanaque + "<td></td><td></td><td></td><td></td><td></td><td></td>";  break;
			case 4: this.almanaque = this.almanaque + "<td></td><td></td><td></td><td></td><td></td>";  break;
			case 5: this.almanaque = this.almanaque + "<td></td><td></td><td></td><td></td>";  break;
			case 6: this.almanaque = this.almanaque + "<td></td><td></td><td></td>";  break;
			case 7: this.almanaque = this.almanaque + "<td></td><td></td>";  break;
			case 1: this.almanaque = this.almanaque + "<td></td>";  break;
			}
			this.almanaque = this.almanaque + "</tr>\n</table>\n";
//			System.out.println(this.almanaque);			
		} catch (ParseException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return almanaque;
	}	

	public void setPos() {
		this.posx[0] = "50px";   this.posy[0]="250px";  this.tit[0] = "efestiu.mes1";
		this.posx[1] = "200px";  this.posy[1]="250px";  this.tit[1] = "efestiu.mes2";
		this.posx[2] = "350px";  this.posy[2]="250px";  this.tit[2] = "efestiu.mes3";
		this.posx[3] = "500px";  this.posy[3]="250px";  this.tit[3] = "efestiu.mes4";
		this.posx[4] = "650px";  this.posy[4]="250px";  this.tit[4] = "efestiu.mes5";
		this.posx[5] = "800px";  this.posy[5]="250px";  this.tit[5] = "efestiu.mes6";
		this.posx[6] = "50px";   this.posy[6]="400px";  this.tit[6] = "efestiu.mes7";
		this.posx[7] = "200px";  this.posy[7]="400px";  this.tit[7] = "efestiu.mes8";
		this.posx[8] = "350px";  this.posy[8]="400px";  this.tit[8] = "efestiu.mes9";
		this.posx[9] = "500px";  this.posy[9]="400px";  this.tit[9] = "efestiu.mes10";
		this.posx[10] = "650px"; this.posy[10]="400px"; this.tit[10] = "efestiu.mes11";
		this.posx[11] = "800px"; this.posy[11]="400px"; this.tit[11] = "efestiu.mes12";		
		this.sem[0] = "efestiu.dias0";
		this.sem[1] = "efestiu.dias1";
		this.sem[2] = "efestiu.dias2";
		this.sem[3] = "efestiu.dias3";
		this.sem[4] = "efestiu.dias4";
		this.sem[5] = "efestiu.dias5";
		this.sem[6] = "efestiu.dias6";
		this.sem[7] = "efestiu.dias7";
	}	
}
