package tornodrom.view;

import java.util.Date;
import java.sql.Time;
import java.sql.Timestamp;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.List;
import java.util.Map;

import tornodrom.control.EmpleatManager;
import tornodrom.control.FestiuManager;
import tornodrom.control.HistorialManager;
import tornodrom.control.IncidenciaManager;
import tornodrom.control.TipuscalendariManager;
import tornodrom.control.TipusincidenciaManager;
import tornodrom.control.TipustornManager;
import tornodrom.list.EmpleatsTab;
import tornodrom.list.HistorialTab;
import tornodrom.list.IncidenciesTab;
import tornodrom.model.Calendaris;
import tornodrom.model.Empleats;
import tornodrom.model.Festius;
import tornodrom.model.Historial;
import tornodrom.model.HistorialPk;
import tornodrom.model.Incidencies;
import tornodrom.model.IncidenciesPk;
import tornodrom.model.TipusCalendaris;
import tornodrom.model.TipusIncidencies;

import com.opensymphony.xwork2.ActionSupport;
import com.opensymphony.xwork2.ActionContext;

public class CincideAction extends ActionSupport {

	private EmpleatManager linkEmpleat;
	private List<Empleats> ecempleList;
	ArrayList<EmpleatsTab> lista;
	private List ecempleDisp = new ArrayList();

	private Map session;
	
	private Empleats empleat;

	private int id;
	private String idEmp;
	private Calendar workany;
	private int any;
	
	private HistorialManager linkHistorial;
	private List<Historial> historialList;
	ArrayList<HistorialTab> hlista;
	private List historialDisp = new ArrayList();

	private IncidenciaManager linkIncidencia;
	private List<Incidencies> incidenciaList;
	ArrayList<IncidenciesTab> ilista;
	private List incidenciaDisp = new ArrayList();
	
	private List<Calendaris> calendariList;
	private Calendar cmpini;
	private Calendar cmpfin;
	private Calendar wrkini;
	private Calendar wrkfin;
	private int[] winc = new int [366];
	private String [] dinc = new String [366];
	private int[] wtcl = new int [366];
	private int[] wtrn = new int [366];
	private String [] dtrn = new String [366];
	private String [] dcolor = new String [366];
	private int[] wfst = new int [366];
	private String [] dfst = new String [366];
	private String [] fcolor = new String [366];
	private String almanaque;
	private String[] posx = new String [12];
	private String[] posy = new String [12];
	private String[] tit = new String [12];
	private String[] sem = new String [8];
	
	private TipuscalendariManager linkTcal;
	private List<TipusCalendaris> tcalList;
	private TipusincidenciaManager linkTinc;
	private List<TipusIncidencies> tincList;
	private TipustornManager linkTtorn;
	private String fttrn;	

	private String di;
	private String hi;
	private Date idataini;
	private String ihoraini;
	private Date idatafin;
	private String ihorafin;
	private String itinc;
	
	private int ftcalid;
	private String ftcalds;	
	private int itincid;
	private String itincds;
	
	private FestiuManager linkFestiu;
	private List<Festius> festiuList;
	private Historial histor;
	private HistorialPk historPk;
	private Incidencies incid;
	private IncidenciesPk incidPk;
	
	public CincideAction() {
		linkEmpleat = new EmpleatManager();
		linkHistorial = new HistorialManager();
		linkIncidencia = new IncidenciaManager();
		linkTcal = new TipuscalendariManager();
		linkTinc = new TipusincidenciaManager();
		linkFestiu = new FestiuManager();
		linkTtorn = new TipustornManager();
		session = ActionContext.getContext().getSession();
		cmpini = Calendar.getInstance();
		cmpfin = Calendar.getInstance();
		wrkini = Calendar.getInstance();
		wrkfin = Calendar.getInstance();
	}	
	
	public String execute() {
		carregaEmpleats(); 
		return SUCCESS;
	}
	public String tornar() {
		return SUCCESS;
	}
	public String detall() {
		if (getId() == 0) {
			setId((Integer)session.get("xidcalemp"));
			setIdEmp((String)session.get("xnomcalemp"));
		}
		// Any actual el que treballem		
		if (session.get("xworkany") == null) {
			workany = Calendar.getInstance();
		} else {
			workany = (Calendar)session.get("xworkany");			
		}
		setAny(workany.get(Calendar.YEAR));

		// Recuperem llista amb les incidencies del any i carreguem
		this.incidenciaList = linkIncidencia.listAny(getId(), getAny());
		setWinc();		
		
		wtrn = new int [366];
		dtrn = new String [366];	
		dcolor = new String [366];	
		String wini = "01-01-" + workany.get(Calendar.YEAR);
		String wfin = "31-12-" + workany.get(Calendar.YEAR);		
		SimpleDateFormat sdwini= new SimpleDateFormat("dd-MM-yyyy"); 
		SimpleDateFormat sdwfin= new SimpleDateFormat("dd-MM-yyyy"); 
		
		// Recuperem llista amb historial
		this.historialList = linkHistorial.listAny(getId(), getAny());
		for (int iter = 0; iter < this.historialList.size(); iter++) {
			try {
				cmpini.setTime(sdwini.parse(wini));
				cmpfin.setTime(sdwfin.parse(wfin));
				wrkini.setTime(this.historialList.get(iter).getId().getDataInici());
				if (this.historialList.get(iter).getDataFi() == null) {
					wrkfin = cmpfin;				
				} else {
					wrkfin.setTime(this.historialList.get(iter).getDataFi());
				}
			} catch (ParseException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			if (cmpini.getTime().after(wrkini.getTime())) wrkini = cmpini;
			if (cmpfin.getTime().before(wrkfin.getTime())) wrkfin = cmpfin;
			this.calendariList = linkHistorial.listTorns(
					this.historialList.get(iter).getId().getDCalendari().getIdTCalendari(), 
					new java.sql.Date(wrkini.getTime().getTime()), 
					new java.sql.Date(wrkfin.getTime().getTime())
			);
			for (int i=0;i<calendariList.size();i++){
				//				Prepara les dades
				Calendar cini = Calendar.getInstance();
				Calendar cfin = Calendar.getInstance();
				cini.setTime(calendariList.get(i).getId().getDataInici());
				if (cini.getTime().before(wrkini.getTime())) cini = wrkini;
				cfin.setTime(calendariList.get(i).getDataFi());
				if (cfin.getTime().after(wrkfin.getTime())) cfin = wrkfin;
				Calendar c = cini;
				while (! c.getTime().after(cfin.getTime())){
					wtcl[c.get(Calendar.DAY_OF_YEAR) - 1] = calendariList.get(i).getId().getDCalendari().getIdTCalendari();
					wtrn[c.get(Calendar.DAY_OF_YEAR) - 1] = calendariList.get(i).getDTTorn().getIdTTorn();
					dtrn[c.get(Calendar.DAY_OF_YEAR) - 1] = calendariList.get(i).getDTTorn().getDescripcio();
					dcolor[c.get(Calendar.DAY_OF_YEAR) - 1] = calendariList.get(i).getDTTorn().getColor();				
					c.add(Calendar.DATE, 1);	
				}
			}
		}
		// Recuperem llista amb els festius del any i carreguem
		this.festiuList = linkFestiu.list(getAny());
		setWfest();
		// Generem calendari		
		this.setAlmanaque(almanaque(workany));
		
		// Mantenim any i empleat
		session.put("xalmanaque", almanaque);
		session.put("xworkany", workany);
		session.put("xidcalemp",getId());
		empleat = linkEmpleat.find(getId());
		setIdEmp(empleat.getNom()+" "+empleat.getPCognom());
		session.put("xnomcalemp",getIdEmp());
		return SUCCESS;
	}
	
	public String restar() {
		workany = (Calendar)session.get("xworkany");
		workany.add(Calendar.YEAR, -1);

		session.put("xalmanaque", almanaque);
		session.put("xworkany", workany);
		return SUCCESS;
	}
	
	public String sumar() {
		workany = (Calendar)session.get("xworkany");
		workany.add(Calendar.YEAR, 1);

		session.put("xalmanaque", almanaque);
		session.put("xworkany", workany);
		return SUCCESS;
	}		

	public String ver() {
		// Obtenir llista tipus incidencies
		tincList = linkTinc.list();
		workany = (Calendar)session.get("xworkany");			
		setAny(workany.get(Calendar.YEAR));	
		setId((Integer)session.get("xidcalemp"));
		setIdEmp((String)session.get("xnomcalemp"));
		SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
		try {
			Date d = sdf.parse(getDi());
			incid = linkIncidencia.view(getId(),new java.sql.Date(d.getTime())).get(0);
			setIdataini(incid.getId().getDataInici());
			setIhoraini(incid.getId().getHoraInici().toString());
			setIdatafin(incid.getDataFi());
			setIhorafin(incid.getHoraFi().toString());
			setItinc(incid.getDTIncidencia().getDescripcio());
			setItincid(incid.getDTIncidencia().getIdTIncidencia());
			setItincds(incid.getDTIncidencia().getDescripcio());
			return SUCCESS;
		} catch (ParseException ex) {
			ex.printStackTrace();
			return ERROR;
		}			
	}

	public List<EmpleatsTab> getEcempleDisp() {
		return ecempleDisp;
	}
	public int getId() {
		return id;
	}
	public String getIdEmp() {
		return idEmp;
	}
	public int getAny() {
		return any;
	}
	public List<HistorialTab> getHistorialDisp() {
		return historialDisp;
	}	
	public String getAlmanaque() {
		return almanaque;
	}
	public String getFttrn() {
		return fttrn;
	}
	public List<TipusCalendaris> getTcalList() {
		return tcalList;
	}
	public int getFtcalid() {
		return ftcalid;
	}
	public String getFtcalds() {
		return ftcalds;
	}
	public List<IncidenciesTab> getIncidenciaDisp() {
		return incidenciaDisp;
	}
	public List<TipusIncidencies> getTincList() {
		return tincList;
	}
	public String getDi() {
		return di;
	}
	public String getHi() {
		return hi;
	}
	public Date getIdataini() {
		return idataini;
	}
	public String getIhoraini() {
		return ihoraini;
	}
	public Date getIdatafin() {
		return idatafin;
	}
	public String getIhorafin() {
		return ihorafin;
	}
	public String getItinc() {
		return itinc;
	}
	public int getItincid() {
		return itincid;
	}
	public String getItincds() {
		return itincds;
	}
	
	public void setEcempleDisp(List<EmpleatsTab> ecempleDisp) {
		this.ecempleDisp = ecempleDisp;
	}
	public void setId(int id) {
		this.id = id;
	}
	public void setIdEmp(String idEmp) {
		this.idEmp = idEmp;
	}
	public void setAny(int any) {
		this.any = any;
	}
	public void setHistorialDisp(List<HistorialTab> historialDisp) {
		this.historialDisp = historialDisp;
	}
	public void setAlmanaque(String almanaque) {
		this.almanaque = almanaque;
	}
	public void setFttrn(String fttrn) {
		this.fttrn = fttrn;
	}
	public void setTcalList(List<TipusCalendaris> tcalList) {
		this.tcalList = tcalList;
	}	
	public void setFtcalid(int ftcalid) {
		this.ftcalid = ftcalid;
	}
	public void setFtcalds(String ftcalds) {
		this.ftcalds = ftcalds;
	}
	public void setIncidenciaDisp(List<IncidenciesTab> incidenciaDisp) {
		this.incidenciaDisp = incidenciaDisp;
	}
	public void setTincList(List<TipusIncidencies> tincList) {
		this.tincList = tincList;
	}
	public void setDi(String di) {
		this.di = di;
	}
	public void setHi(String hi) {
		this.hi = hi;
	}	
	public void setIdataini(Date idataini) {
		this.idataini = idataini;
	}
	public void setIhoraini(String ihoraini) {
		this.ihoraini = ihoraini;
	}
	public void setIdatafin(Date idatafin) {
		this.idatafin = idatafin;
	}
	public void setIhorafin(String ihorafin) {
		this.ihorafin = ihorafin;
	}
	public void setItinc(String itinc) {
		this.itinc = itinc;
	}
	public void setItincid(int itincid) {
		this.itincid = itincid;
	}
	public void setItincds(String itincds) {
		this.itincds = itincds;
	}
	
	public void carregaEmpleats() {
		this.ecempleList = linkEmpleat.list(((Integer)session.get("xidempl")).intValue());
		for (int iter = 0; iter < this.ecempleList.size(); iter++) {
			this.ecempleDisp.add(
					new EmpleatsTab(
							this.ecempleList.get(iter).getIdEmpleat(), 
							this.ecempleList.get(iter).getNIdentificacio(),
							this.ecempleList.get(iter).getNom() + " " +
							this.ecempleList.get(iter).getPCognom() + " " +
							this.ecempleList.get(iter).getSCognom(),
							this.ecempleList.get(iter).getTelefon(),
							this.ecempleList.get(iter).getCorreu(),
							this.ecempleList.get(iter).getDataIncorporacio(),
							this.ecempleList.get(iter).getDataBaixa(),
							"<a href=\"cincideH?id=" + this.ecempleList.get(iter).getIdEmpleat()
							+ "\">" + getText("cincide.tbl.accio") + "</a>"
			));
		}
	}

	public void setWinc() {
		winc = new int [366];
		dinc = new String [366];	
		for (int i=0;i<incidenciaList.size();i++){
//			Prepara les dades
			Calendar cini = Calendar.getInstance();
			Calendar cfin = Calendar.getInstance();
			cini.setTime(incidenciaList.get(i).getId().getDataInici());
			cfin.setTime(incidenciaList.get(i).getDataFi());
			Calendar c = cini;
			while (! c.getTime().after(cfin.getTime())){
				winc[c.get(Calendar.DAY_OF_YEAR) - 1] = incidenciaList.get(i).getDTIncidencia().getIdTIncidencia();
				dinc[c.get(Calendar.DAY_OF_YEAR) - 1] = incidenciaList.get(i).getDTIncidencia().getDescripcio();
				c.add(Calendar.DATE, 1);	
			}
		}
	}
	
	public void setWfest() {
		wfst = new int [366];
		dfst = new String [366];	
  		fcolor = new String [366];	
		for (int i=0;i<festiuList.size();i++){
//			Prepara les dades
			Calendar cini = Calendar.getInstance();
			Calendar cfin = Calendar.getInstance();
			cini.setTime(festiuList.get(i).getDataInici());
			cfin.setTime(festiuList.get(i).getDataFi());
			Calendar c = cini;
			while (! c.getTime().after(cfin.getTime())){
				wfst[c.get(Calendar.DAY_OF_YEAR) - 1] = festiuList.get(i).getDTFestiu().getIdTFestiu();
				dfst[c.get(Calendar.DAY_OF_YEAR) - 1] = festiuList.get(i).getDTFestiu().getDescripcio();
				fcolor[c.get(Calendar.DAY_OF_YEAR) - 1] = festiuList.get(i).getDTFestiu().getColor();				
				c.add(Calendar.DATE, 1);	
			}
		}
	}
	
	public String almanaque(Calendar work){
		this.almanaque = "";
		setPos();
		int omes = -1;
		int oweek = 0;
		String wini = "01-01-" + work.get(Calendar.YEAR);
		String wfin = "31-12-" + work.get(Calendar.YEAR);		
		SimpleDateFormat sdwini= new SimpleDateFormat("dd-MM-yyyy"); 
		SimpleDateFormat sdwfin= new SimpleDateFormat("dd-MM-yyyy"); 
		try {
//			Prepara les dades
			Calendar cini = Calendar.getInstance();
			Calendar cfin = Calendar.getInstance();			
			cini.setTime(sdwini.parse(wini));
			cfin.setTime(sdwfin.parse(wfin));
			Calendar c = cini;
			while (! c.getTime().after(cfin.getTime())){
				// Canvi de mes
				if (omes != c.get(Calendar.MONTH)) {
					if (omes != -1) {
						switch (c.get(Calendar.DAY_OF_WEEK)){
						case 3: this.almanaque = this.almanaque + "<td></td><td></td><td></td><td></td><td></td><td></td>"; break;
						case 4: this.almanaque = this.almanaque + "<td></td><td></td><td></td><td></td><td></td>";  break;
						case 5: this.almanaque = this.almanaque + "<td></td><td></td><td></td><td></td>";  break;
						case 6: this.almanaque = this.almanaque + "<td></td><td></td><td></td>";  break;
						case 7: this.almanaque = this.almanaque + "<td></td><td></td>";  break;
						case 1: this.almanaque = this.almanaque + "<td></td>";  break;
						}
						this.almanaque = this.almanaque + "</tr>\n</table>\n";
					}
					// nova taula
					this.almanaque = this.almanaque + "<table style=\"font-family:Calibri; font-size:12px;position: absolute;left:" + this.posx[c.get(Calendar.MONTH)]+";top:" + this.posy[c.get(Calendar.MONTH)]+";\">\n";
					// capalera
					this.almanaque = this.almanaque + "<tr><th align=center colspan=8>" + getText(tit[c.get(Calendar.MONTH)])+"</th></tr>\n";
					this.almanaque = this.almanaque + "<tr><td style=\"color:#FE9A2E;\">" + getText(sem[0]) + "</td><td style=\"color:#0101DF;\">" + getText(sem[1]) + "</td><td style=\"color:#0101DF;\">" + getText(sem[2]) + "</td><td style=\"color:#0101DF;\">" + getText(sem[3]) + "</td><td style=\"color:#0101DF;\">" + getText(sem[4]) + "</td><td style=\"color:#0101DF;\">" + getText(sem[5]) + "</td><td style=\"color:#0101DF;\">" + getText(sem[6]) + "</td><td style=\"color:#0101DF;\">" + getText(sem[7]) + "</td></tr>\n";
					omes = c.get(Calendar.MONTH);
					// provoquem un canvi de setmana
					oweek = 0;
				}
//				Canvi de setmana
				if (oweek != c.get(Calendar.WEEK_OF_YEAR)) {
					if (oweek != 0) this.almanaque = this.almanaque + "</tr>\n";
					switch (c.get(Calendar.DAY_OF_WEEK)){
					case 2: this.almanaque = this.almanaque + "<tr><td align=\"right\" style=\"color:#FF8000;\">" + c.get(Calendar.WEEK_OF_YEAR) + "</td>"; break;
					case 3: this.almanaque = this.almanaque + "<tr><td align=\"right\" style=\"color:#FF8000;\">" + c.get(Calendar.WEEK_OF_YEAR) + "</td><td></td>"; break;
					case 4: this.almanaque = this.almanaque + "<tr><td align=\"right\" style=\"color:#FF8000;\">" + c.get(Calendar.WEEK_OF_YEAR) + "</td><td></td><td></td>"; break;					
					case 5: this.almanaque = this.almanaque + "<tr><td align=\"right\" style=\"color:#FF8000;\">" + c.get(Calendar.WEEK_OF_YEAR) + "</td><td></td><td></td><td></td>"; break;
					case 6: this.almanaque = this.almanaque + "<tr><td align=\"right\" style=\"color:#FF8000;\">" + c.get(Calendar.WEEK_OF_YEAR) + "</td><td></td><td></td><td></td><td></td>"; break;	
					case 7: this.almanaque = this.almanaque + "<tr><td align=\"right\" style=\"color:#FF8000;\">" + c.get(Calendar.WEEK_OF_YEAR) + "</td><td></td><td></td><td></td><td></td><td></td>"; break;					
					case 1: this.almanaque = this.almanaque + "<tr><td align=\"right\" style=\"color:#FF8000;\">" + c.get(Calendar.WEEK_OF_YEAR) + "</td><td></td><td></td><td></td><td></td><td></td><td></td>"; break;
					}
					oweek = c.get(Calendar.WEEK_OF_YEAR);					
				}
				if (wtrn[c.get(Calendar.DAY_OF_YEAR) - 1] != 0) {
					if (wfst[c.get(Calendar.DAY_OF_YEAR) - 1] != 0) {
						if (winc[c.get(Calendar.DAY_OF_YEAR) - 1] != 0) {
							SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
							this.almanaque = this.almanaque + "<td bgcolor=\"" + 
								dcolor[c.get(Calendar.DAY_OF_YEAR) - 1] + "\"  title = \"" + 
								dinc[c.get(Calendar.DAY_OF_YEAR) - 1] + " - " + dtrn[c.get(Calendar.DAY_OF_YEAR) - 1] + " - " + dfst[c.get(Calendar.DAY_OF_YEAR) - 1] + 
								"\" align=\"right\" " + 
								"onclick=\"document.location.href = 'cincideS?di=" + 
								sdf.format(c.getTime())+ "'\" style=\"border: solid 0 #F00; border-bottom-width:3px; cursor:pointer\">" + 
								c.get(Calendar.DAY_OF_MONTH)+ "</td>";							
						} else {
							SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
							this.almanaque = this.almanaque + "<td bgcolor=\"" + 
								dcolor[c.get(Calendar.DAY_OF_YEAR) - 1] + "\"  title = \"" + 
								dtrn[c.get(Calendar.DAY_OF_YEAR) - 1] + " - " + dfst[c.get(Calendar.DAY_OF_YEAR) - 1] + 
								"\" align=\"right\" \" style=\"border: solid 0 #000; border-bottom-width:2px\">" +	c.get(Calendar.DAY_OF_MONTH)+ "</td>";
						}
					} else {
						if (winc[c.get(Calendar.DAY_OF_YEAR) - 1] != 0) {
							SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
							this.almanaque = this.almanaque + "<td bgcolor=\"" + 
								dcolor[c.get(Calendar.DAY_OF_YEAR) - 1] + "\"  title = \"" + 
								dinc[c.get(Calendar.DAY_OF_YEAR) - 1] + " - " + dtrn[c.get(Calendar.DAY_OF_YEAR) - 1] + "\" align=\"right\" " + 
								"onclick=\"document.location.href = 'cincideS?di=" + 
								sdf.format(c.getTime())+ "'\" style=\"border: solid 0 #F00; border-bottom-width:3px; cursor:pointer\">" + 
								c.get(Calendar.DAY_OF_MONTH)+ "</td>";							
						} else {
							SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
							this.almanaque = this.almanaque + "<td bgcolor=\"" + 
								dcolor[c.get(Calendar.DAY_OF_YEAR) - 1] + "\"  title = \"" + 
								dtrn[c.get(Calendar.DAY_OF_YEAR) - 1] + "\" align=\"right\">" + 
								c.get(Calendar.DAY_OF_MONTH)+ "</td>";
						}
					}
				} else {
					if (wfst[c.get(Calendar.DAY_OF_YEAR) - 1] != 0) {
						if (winc[c.get(Calendar.DAY_OF_YEAR) - 1] != 0) {
							SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
							this.almanaque = this.almanaque + "<td bgcolor=\"" + 
								fcolor[c.get(Calendar.DAY_OF_YEAR) - 1] + "\"  title = \"" + 
								dinc[c.get(Calendar.DAY_OF_YEAR) - 1] + " - " + dfst[c.get(Calendar.DAY_OF_YEAR) - 1] + "\" align=\"right\" " + 
								"onclick=\"document.location.href = 'cincideS?di=" + 
								sdf.format(c.getTime())+ "'\" style=\"border: solid 0 #F00; border-bottom-width:3px;cursor:pointer\">" + 
								c.get(Calendar.DAY_OF_MONTH)+ "</td>";										
						} else {
							this.almanaque = this.almanaque + "<td bgcolor=\"" + 
								fcolor[c.get(Calendar.DAY_OF_YEAR) - 1] + "\"  title = \"" + 
								dfst[c.get(Calendar.DAY_OF_YEAR) - 1] + "\" align=\"right\">" + 
								c.get(Calendar.DAY_OF_MONTH)+ "</td>";
						}
					} else {
						if (winc[c.get(Calendar.DAY_OF_YEAR) - 1] != 0) {
							SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
							this.almanaque = this.almanaque + "<td " + "title = \"" + 
								dinc[c.get(Calendar.DAY_OF_YEAR) - 1] + "\" align=\"right\" " + 
								"onclick=\"document.location.href = 'cincideS?di=" + 
								sdf.format(c.getTime())+ "'\" style=\"border: solid 0 #F00; border-bottom-width:3px;cursor:pointer\">" + 
								c.get(Calendar.DAY_OF_MONTH)+ "</td>";							
						} else {
							this.almanaque = this.almanaque + "<td align=\"right\">" + c.get(Calendar.DAY_OF_MONTH)+ "</td>";
						}
					}
				}
				c.add(Calendar.DATE, 1);
			}
			switch (c.get(Calendar.DAY_OF_WEEK)){
			case 3: this.almanaque = this.almanaque + "<td></td><td></td><td></td><td></td><td></td><td></td>";  break;
			case 4: this.almanaque = this.almanaque + "<td></td><td></td><td></td><td></td><td></td>";  break;
			case 5: this.almanaque = this.almanaque + "<td></td><td></td><td></td><td></td>";  break;
			case 6: this.almanaque = this.almanaque + "<td></td><td></td><td></td>";  break;
			case 7: this.almanaque = this.almanaque + "<td></td><td></td>";  break;
			case 1: this.almanaque = this.almanaque + "<td></td>";  break;
			}
			this.almanaque = this.almanaque + "</tr>\n</table>\n";
//			System.out.println(this.almanaque);			
		} catch (ParseException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return almanaque;
	}	

	public void setPos() {
		this.posx[0] = "50px";   this.posy[0]="250px";  this.tit[0] = "efestiu.mes1";
		this.posx[1] = "200px";  this.posy[1]="250px";  this.tit[1] = "efestiu.mes2";
		this.posx[2] = "350px";  this.posy[2]="250px";  this.tit[2] = "efestiu.mes3";
		this.posx[3] = "500px";  this.posy[3]="250px";  this.tit[3] = "efestiu.mes4";
		this.posx[4] = "650px";  this.posy[4]="250px";  this.tit[4] = "efestiu.mes5";
		this.posx[5] = "800px";  this.posy[5]="250px";  this.tit[5] = "efestiu.mes6";
		this.posx[6] = "50px";   this.posy[6]="400px";  this.tit[6] = "efestiu.mes7";
		this.posx[7] = "200px";  this.posy[7]="400px";  this.tit[7] = "efestiu.mes8";
		this.posx[8] = "350px";  this.posy[8]="400px";  this.tit[8] = "efestiu.mes9";
		this.posx[9] = "500px";  this.posy[9]="400px";  this.tit[9] = "efestiu.mes10";
		this.posx[10] = "650px"; this.posy[10]="400px"; this.tit[10] = "efestiu.mes11";
		this.posx[11] = "800px"; this.posy[11]="400px"; this.tit[11] = "efestiu.mes12";		
		this.sem[0] = "efestiu.dias0";
		this.sem[1] = "efestiu.dias1";
		this.sem[2] = "efestiu.dias2";
		this.sem[3] = "efestiu.dias3";
		this.sem[4] = "efestiu.dias4";
		this.sem[5] = "efestiu.dias5";
		this.sem[6] = "efestiu.dias6";
		this.sem[7] = "efestiu.dias7";
	}
}
