package tornodrom.view;

import java.util.Date;
import java.sql.Time;
import java.sql.Timestamp;
import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.List;
import java.util.Map;

import tornodrom.control.EmpleatManager;
import tornodrom.control.IdentificatiuManager;
import tornodrom.control.ResponsableManager;
import tornodrom.list.EmpleatsTab;
import tornodrom.model.Empleats;
import tornodrom.model.Identificatius;
import tornodrom.model.Responsables;
import tornodrom.model.ResponsablesPk;

import com.opensymphony.xwork2.ActionContext;
import com.opensymphony.xwork2.ActionSupport;

public class EempleaAction extends ActionSupport {

	private int id;
	
	private EmpleatManager linkEmpleat;
	private List<Empleats> empleatList;
	ArrayList<EmpleatsTab> lista;
	private List empleatDisp = new ArrayList();	

	private IdentificatiuManager linkIdentis;
	private List<Identificatius> identifList;	
	private Map session;
	
	private Empleats empleat;
	private String vnom;
	private String vpcg;
	private String vscg;
	private String vide;
	private String vnif;
	private String vtel;
	private String vcor;
	private Date vdna;
	private Date vdin;
	private Date vdba;

	private int videid;
	private String videdes;	
	
	private ResponsableManager linkResp;
	private Responsables resp;
	private ResponsablesPk respPk;
	
	public EempleaAction() {
		linkEmpleat = new EmpleatManager();
		linkIdentis = new IdentificatiuManager();
		linkResp = new ResponsableManager();
		session = ActionContext.getContext().getSession();
	}	
	
	public String execute() {
		return SUCCESS;
	}

	public String llista() {
		this.empleatList = linkEmpleat.list(((Integer)session.get("xidempl")).intValue());
		for (int iter = 0; iter < this.empleatList.size(); iter++) {
			this.empleatDisp.add(
					new EmpleatsTab(
							this.empleatList.get(iter).getIdEmpleat(), 
							this.empleatList.get(iter).getNIdentificacio(),
							this.empleatList.get(iter).getNom() + " " +
							this.empleatList.get(iter).getPCognom() + " " +
							this.empleatList.get(iter).getSCognom(),
							this.empleatList.get(iter).getTelefon(),
							this.empleatList.get(iter).getCorreu(),
							this.empleatList.get(iter).getDataIncorporacio(),
							this.empleatList.get(iter).getDataBaixa(),
							"<a href=\"eempleaM?id=" + this.empleatList.get(iter).getIdEmpleat()
							+ "\">" + getText("eemplea.label.upd") + "</a> | "
							+ "<a href=\"eempleaD?id=" + this.empleatList.get(iter).getIdEmpleat()
							+ "\">" + getText("eemplea.label.del") + "</a>"
			));
		}
		return SUCCESS;
	}
	
	public String preadd() {
		// Obtenir identificatius
		this.identifList = linkIdentis.list();
		return SUCCESS;
	}
	public String add() {
		// Obtenir identificatius
		this.identifList = linkIdentis.list();
		if (validation()) {
			empleat = new Empleats();
			empleat.setNom(getVnom());
			empleat.setPCognom(getVpcg());
			empleat.setSCognom(getVscg());
			empleat.setDIdentificatiu(linkIdentis.find(Integer.parseInt(vide)));
			empleat.setNIdentificacio(getVnif());
			empleat.setTelefon(getVtel());
			empleat.setCorreu(getVcor());
			empleat.setDataNaixament(new java.sql.Date(getVdna().getTime()));
			empleat.setDataIncorporacio(new java.sql.Date(getVdin().getTime()));
			if (vdba != null)
				empleat.setDataBaixa(new java.sql.Date(getVdba().getTime()));
			empleat.setUsuariAlta((String)session.get("xusuari"));
			empleat.setTmstmpAlta(new Timestamp(Calendar.getInstance().getTime().getTime()));
			linkEmpleat.add(empleat);
			// alta responsable
			resp = new Responsables();
			respPk = new ResponsablesPk(empleat.getIdEmpleat(),(Integer)session.get("xidempl"),new java.sql.Date(getVdin().getTime()));
			respPk.setDEmpleat(empleat);
			respPk.setDResponsable(linkEmpleat.find((Integer)session.get("xidempl")));
			resp.setId(respPk);
			resp.setUsuariAlta((String)session.get("xusuari"));
			resp.setTmstmpAlta(new Timestamp(Calendar.getInstance().getTime().getTime()));
			linkResp.add(resp);
			return SUCCESS;
		} else {
			return ERROR;
		}
	}

	public String previous() {
		// Obtenir identificatius
		this.identifList = linkIdentis.list();
		empleat = linkEmpleat.find(getId());
		setVnom(empleat.getNom());
		setVpcg(empleat.getPCognom());
		setVscg(empleat.getSCognom());
		setVide(empleat.getDIdentificatiu().getDescripcio());
		setVideid(empleat.getDIdentificatiu().getIdIdentificatiu());
		setVidedes(empleat.getDIdentificatiu().getDescripcio());
		setVnif(empleat.getNIdentificacio());
		setVtel(empleat.getTelefon());
		setVcor(empleat.getCorreu());
		setVdna(empleat.getDataNaixament());
		setVdin(empleat.getDataIncorporacio());
		setVdba(empleat.getDataBaixa());
		return SUCCESS;
	}	
	
	public String mod() {
		// Obtenir identificatius
		this.identifList = linkIdentis.list();
		if (validationMod()) {
			empleat = linkEmpleat.find(getId());
			empleat.setNom(getVnom());
			empleat.setPCognom(getVpcg());
			empleat.setSCognom(getVscg());
			empleat.setDIdentificatiu(linkIdentis.find(Integer.parseInt(vide)));
			empleat.setNIdentificacio(getVnif());
			empleat.setTelefon(getVtel());
			empleat.setCorreu(getVcor());
			empleat.setDataNaixament(new java.sql.Date(getVdna().getTime()));
			empleat.setDataIncorporacio(new java.sql.Date(getVdin().getTime()));
			if (vdba != null)
				empleat.setDataBaixa(new java.sql.Date(getVdba().getTime()));
			empleat.setUsuariModi((String)session.get("xusuari"));
			empleat.setTmstmpModi(new Timestamp(Calendar.getInstance().getTime().getTime()));
			linkEmpleat.update(empleat);
			// modificacion responsable
			if (vdba != null) {
				resp = new Responsables();
				respPk = new ResponsablesPk(empleat.getIdEmpleat(),(Integer)session.get("xidempl"),new java.sql.Date(getVdin().getTime()));
				respPk.setDEmpleat(empleat);
				respPk.setDResponsable(linkEmpleat.find((Integer)session.get("xidempl")));
				resp = linkResp.find(respPk);
				resp.setDataFi(new java.sql.Date(getVdba().getTime()));
				resp.setUsuariModi((String)session.get("xusuari"));
				resp.setTmstmpModi(new Timestamp(Calendar.getInstance().getTime().getTime()));
				linkResp.update(resp);				
			}
			return SUCCESS;
		} else {
			return ERROR;
		}
	}		

	public String del() {
		empleat = linkEmpleat.find(getId());
		empleat.setUsuariBaja((String)session.get("xusuari"));
		empleat.setTmstmpBaja(new Timestamp(Calendar.getInstance().getTime().getTime()));
		linkEmpleat.delete(empleat);
		// baixa responsable
		resp = new Responsables();
		respPk = new ResponsablesPk(empleat.getIdEmpleat(),(Integer)session.get("xidempl"),new java.sql.Date(getVdin().getTime()));
		respPk.setDEmpleat(empleat);
		respPk.setDResponsable(linkEmpleat.find((Integer)session.get("xidempl")));
		resp = linkResp.find(respPk);
		resp.setDataFi(new java.sql.Date(new java.util.Date().getTime()));
		resp.setUsuariBaja((String)session.get("xusuari"));
		resp.setTmstmpBaja(new Timestamp(Calendar.getInstance().getTime().getTime()));
		linkResp.update(resp);
		return SUCCESS;
	}				
	
	public int getId () {
		return id;
	}
	public List<EmpleatsTab> getEmpleatDisp() {
		return empleatDisp;
	}	
	public String getVnom(){
		return vnom;
	}
	public String getVpcg(){
		return vpcg;
	}
	public String getVscg(){
		return vscg;
	}	
	public String getVide(){
		return vide;
	}
	public int getVideid(){
		return videid;
	}
	public String getVidedes(){
		return videdes;
	}
	public String getVnif(){
		return vnif;
	}
	public String getVtel(){
		return vtel;
	}	
	public String getVcor(){
		return vcor;
	}	
	public Date getVdna(){
		return vdna;
	}
	public Date getVdin(){
		return vdin;
	}
	public Date getVdba(){
		return vdba;
	}
	public List<Identificatius> getIdentifList() {
		return identifList;
	}	
	
	public void setId (int id){
		this.id = id;
	}
	public void setEmpleatDisp(List<EmpleatsTab> empleatDisp) {
		this.empleatDisp = empleatDisp;
	}	
	public void setVnom (String vnom) {
		this.vnom = vnom;
	}
	public void setVpcg (String vpcg) {
		this.vpcg = vpcg;
	}
	public void setVscg (String vscg) {
		this.vscg = vscg;
	}
	public void setVide (String vide) {
		this.vide = vide;
	}
	public void setVideid (int videid) {
		this.videid = videid;
	}
	public void setVidedes (String videdes) {
		this.videdes = videdes;
	}		
	public void setVnif (String vnif) {
		this.vnif = vnif;
	}
	public void setVtel (String vtel) {
		this.vtel = vtel;
	}
	public void setVcor (String vcor) {
		this.vcor = vcor;
	}
	public void setVdna (Date vdna) {
		this.vdna = vdna;
	}		
	public void setVdin (Date vdin) {
		this.vdin = vdin;
	}
	public void setVdba (Date vdba) {
		this.vdba = vdba;
	}	
	public void setIdentifList (List<Identificatius> identifList) {
		this.identifList = identifList;
	}	
	
	public Boolean validation() {
		if (vnom == null || vnom.trim().equals("")) {
			addActionError(getText("eemplea.error.1"));
			return false;
		}
		if (vpcg == null || vpcg.trim().equals("")) {
			addActionError(getText("eemplea.error.2"));
			return false;
		}
		if (vide == null || vide.equals("0")) {
			addActionError(getText("eemplea.error.3"));
			return false;			
		}		
		if (vnif == null || vnif.trim().equals("")) {
			addActionError(getText("eemplea.error.4"));
			return false;
		}
		if (linkEmpleat.check(vnif) != 0) {
			addActionError(getText("eemplea.error.5"));
			return false;						
		}		
		if (vtel == null || vtel.trim().equals("")) {
			addActionError(getText("eemplea.error.6"));
			return false;
		}
		if (vcor == null || vcor.trim().equals("")) {
			addActionError(getText("eemplea.error.7"));
			return false;
		}
		if (vdna == null) {
			addActionError(getText("eemplea.error.8"));
			return false;
		}
		if (vdin == null) {
			addActionError(getText("eemplea.error.9"));
			return false;
		}
		if (vdna.after(vdin)) {
			addActionError(getText("eemplea.error.10"));
			return false;			
		}
		if (vdba != null && vdin.after(vdba)) {
			addActionError(getText("eemplea.error.11"));
			return false;				
		}
		return true;
	}
	
	public Boolean validationMod() {
		if (vnom == null || vnom.trim().equals("")) {
			addActionError(getText("eemplea.error.1"));
			return false;
		}
		if (vpcg == null || vpcg.trim().equals("")) {
			addActionError(getText("eemplea.error.2"));
			return false;
		}
		if (vide == null || vide.equals("0")) {
			addActionError(getText("eemplea.error.3"));
			return false;			
		}		
		if (vnif == null || vnif.trim().equals("")) {
			addActionError(getText("eemplea.error.4"));
			return false;
		}
		if (vtel == null || vtel.trim().equals("")) {
			addActionError(getText("eemplea.error.6"));
			return false;
		}
		if (vcor == null || vcor.trim().equals("")) {
			addActionError(getText("eemplea.error.7"));
			return false;
		}
		if (vdna == null) {
			addActionError(getText("eemplea.error.8"));
			return false;
		}
		if (vdin == null) {
			addActionError(getText("eemplea.error.9"));
			return false;
		}
		if (vdna.after(vdin)) {
			addActionError(getText("eemplea.error.10"));
			return false;			
		}
		if (vdba != null && vdin.after(vdba)) {
			addActionError(getText("eemplea.error.11"));
			return false;				
		}
		return true;
	}
}
