package tornodrom.view;

import java.sql.Timestamp;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.List;
import java.util.Map;
import java.util.Date;

import tornodrom.control.FestiuManager;
import tornodrom.control.TipusfestiuManager;
import tornodrom.list.FestiusTab;
import tornodrom.model.Festius;
import tornodrom.model.TipusFestius;

import com.opensymphony.xwork2.ActionContext;
import com.opensymphony.xwork2.ActionSupport;

public class EfestiuAction extends ActionSupport {

	private String id;
	
	private Map session;
	private FestiuManager linkFestiu;
	private TipusfestiuManager linkTfestiu;
	private List<Festius> festesList;
	private List<TipusFestius> ctfestiList;
	
	ArrayList<FestiusTab> lista;
	private List festesDisp = new ArrayList();	

	private int any;
	private Calendar workany;
	
	private Festius festius;
	private Date fdataini;
	private Date fdatafin;
	private String ftfestiu;
	private int ftfid;
	private String ftfds;
	
	private Boolean csabados;
	private Boolean cdomings;
	
	private String almanaque;
	private int[] wfesta = new int [366];
	private String [] dfesta = new String [366];
	private String [] dcolor = new String [366];	
	private String[] posx = new String [12];
	private String[] posy = new String [12];
	private String[] tit = new String [12];
	private String[] sem = new String [8];	
	

	public EfestiuAction() {
		linkFestiu = new FestiuManager();
		linkTfestiu = new TipusfestiuManager();
		session = ActionContext.getContext().getSession();		
	}	
	
	public String execute() {
		if (getId() != null ) {
			ver();
		} else {
			preparar();
		}
		return SUCCESS;
	}
	public String restar() {
		this.ctfestiList = linkTfestiu.list();

		workany = (Calendar)session.get("xworkany");
		workany.add(Calendar.YEAR, -1);

		session.put("xalmanaque", almanaque);
		session.put("xworkany", workany);
		return SUCCESS;
	}	
	public String sumar() {
		this.ctfestiList = linkTfestiu.list();

		workany = (Calendar)session.get("xworkany");
		workany.add(Calendar.YEAR, 1);

		session.put("xalmanaque", almanaque);
		session.put("xworkany", workany);
		return SUCCESS;
	}			
	public void ver() {
		workany = (Calendar)session.get("xworkany");
		setAny(workany.get(Calendar.YEAR));	
		SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
		try {
			Date d = sdf.parse(getId());
			festesList = linkFestiu.view(new java.sql.Date(d.getTime()));
			setFdataini(festesList.get(0).getDataInici());
			setFdatafin(festesList.get(0).getDataFi());
			setFtfestiu(festesList.get(0).getDTFestiu().getDescripcio());
		} catch (ParseException ex) {
			ex.printStackTrace();
		}
	}
	public String tornar() {
		return SUCCESS;
	}
	public String preadd() {
		// Obtenir llista tipus festius
		this.ctfestiList = linkTfestiu.list();
		workany = (Calendar)session.get("xworkany");			
		setAny(workany.get(Calendar.YEAR));		
		return SUCCESS;
	}
	public String add() {
		// Obtenir llista tipus festius
		this.ctfestiList = linkTfestiu.list();
		workany = (Calendar)session.get("xworkany");			
		setAny(workany.get(Calendar.YEAR));	
		
		// Filtrar dades
		if (!validation()) return ERROR;

		// Buscar si existeix data inicial
		Festius festa = linkFestiu.find(new java.sql.Date(fdataini.getTime()));
		if (null != festa) {
			// Si existeix modificar
			festa.setDataFi(new java.sql.Date(fdatafin.getTime()));
			festa.setDTFestiu(this.ctfestiList.get(Integer.parseInt(ftfestiu) - 1));
			festa.setUsuariModi((String)session.get("xusuari"));
			festa.setTmstmpModi(new Timestamp(Calendar.getInstance().getTime().getTime()));
			if (festa.getTmstmpBaja() != null) {
				festa.setUsuariBaja(null);
				festa.setTmstmpBaja(null);
			}
			linkFestiu.update(festa);			
		} else {
			// Sino existeix donar d'alta
			festa = new Festius();
			festa.setDataInici(new java.sql.Date(fdataini.getTime()));
			festa.setDataFi(new java.sql.Date(fdatafin.getTime()));
			festa.setDTFestiu(this.ctfestiList.get(Integer.parseInt(ftfestiu) - 1));
			festa.setUsuariAlta((String)session.get("xusuari"));
			festa.setTmstmpAlta(new Timestamp(Calendar.getInstance().getTime().getTime()));
			linkFestiu.add(festa);
		}
		return SUCCESS;
	}
	public String create() {
		this.ctfestiList = linkTfestiu.list();

		workany = (Calendar)session.get("xworkany");
		String wini = "01-01-" + workany.get(Calendar.YEAR);
		String wfin = "31-12-" + workany.get(Calendar.YEAR);		
		SimpleDateFormat sdwini= new SimpleDateFormat("dd-MM-yyyy"); 
		SimpleDateFormat sdwfin= new SimpleDateFormat("dd-MM-yyyy"); 
		try {
//			Prepara les dades
			Calendar cini = Calendar.getInstance();
			Calendar cfin = Calendar.getInstance();			
			cini.setTime(sdwini.parse(wini));
			cfin.setTime(sdwfin.parse(wfin));
			Calendar c = cini;
			while (! c.getTime().after(cfin.getTime())){
				// Dissabtes
				if (csabados && c.get(Calendar.DAY_OF_WEEK) == 7) {
					// Buscar si existeix data inicial
					Festius festa = linkFestiu.find(new java.sql.Date(c.getTime().getTime()));					
					if (null == festa) {
						festa = new Festius();
						festa.setDataInici(new java.sql.Date(c.getTime().getTime()));
						festa.setDataFi(new java.sql.Date(c.getTime().getTime()));
						festa.setDTFestiu(this.ctfestiList.get(0));
						festa.setUsuariAlta((String)session.get("xusuari"));
						festa.setTmstmpAlta(new Timestamp(Calendar.getInstance().getTime().getTime()));
						linkFestiu.add(festa);						
					}
				}
				// Diumenges				
				if (cdomings && c.get(Calendar.DAY_OF_WEEK) == 1) {
					Festius festa = linkFestiu.find(new java.sql.Date(c.getTime().getTime()));					
					if (null == festa) {
						festa = new Festius();
						festa.setDataInici(new java.sql.Date(c.getTime().getTime()));
						festa.setDataFi(new java.sql.Date(c.getTime().getTime()));
						festa.setDTFestiu(this.ctfestiList.get(1));
						festa.setUsuariAlta((String)session.get("xusuari"));
						festa.setTmstmpAlta(new Timestamp(Calendar.getInstance().getTime().getTime()));
						linkFestiu.add(festa);						
					}					
				} 
				c.add(Calendar.DATE, 1);
			}
		} catch (ParseException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}		
		return SUCCESS;
	}
	public String premod() {
		this.ctfestiList = linkTfestiu.list();
		workany = (Calendar)session.get("xworkany");			
		setAny(workany.get(Calendar.YEAR));
		SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
//		SimpleDateFormat sdf2 = new SimpleDateFormat("dd-MM-yyyy");
		try {
			Date d = sdf.parse(getId());
			festius = linkFestiu.find(new java.sql.Date(d.getTime()));
			setFdataini(festius.getDataInici());
			String s = festius.getDataFi().toString();
			setFdatafin(festius.getDataFi());
			setFtfestiu(festius.getDTFestiu().getDescripcio());
			setFtfid(festius.getDTFestiu().getIdTFestiu());
			setFtfds(festius.getDTFestiu().getDescripcio());
		} catch (ParseException ex) {
			ex.printStackTrace();
		}		
		return SUCCESS;
	}	
	public String mod() {
		// Obtenir llista tipus festius
		this.ctfestiList = linkTfestiu.list();
		workany = (Calendar)session.get("xworkany");			
		setAny(workany.get(Calendar.YEAR));	

		// Buscar si existeix data inicial
		Festius festa = linkFestiu.find(new java.sql.Date(fdataini.getTime()));

		// Filtrar dades
		if (!validationMod()) return ERROR;		
		
		// Si existeix modificar
		festa.setDataFi(new java.sql.Date(fdatafin.getTime()));
		festa.setDTFestiu(this.ctfestiList.get(Integer.parseInt(ftfestiu) - 1));
		festa.setUsuariModi((String)session.get("xusuari"));
		festa.setTmstmpModi(new Timestamp(Calendar.getInstance().getTime().getTime()));
		if (festa.getTmstmpBaja() != null) {
			festa.setUsuariBaja(null);
			festa.setTmstmpBaja(null);
		}
		linkFestiu.update(festa);			
		
		return SUCCESS;
	}
	public String del() {
		festius = linkFestiu.find(new java.sql.Date(getFdataini().getTime()));
		festius.setUsuariBaja((String)session.get("xusuari"));
		festius.setTmstmpBaja(new Timestamp(Calendar.getInstance().getTime().getTime()));
		linkFestiu.delete(festius);
		return SUCCESS;
	}		
	
	public String getId() {
		return id;
	}
	public int getAny() {
		return any;
	}
	public List<FestiusTab> getFestesDisp() {
		return festesDisp;
	}
	public List<TipusFestius> getCtfestiList() {
		return ctfestiList;
	}	
	public Date getFdataini() {
		return fdataini;
	}
	public Date getFdatafin() {
		return fdatafin;
	}	
	public String getFtfestiu() {
		return ftfestiu;
	}
	public int getFtfid() {
		return ftfid;
	}
	public String getFtfds() {
		return ftfds;
	}
	public Boolean getCsabados() {
		return csabados;
	}
	public Boolean getCdomings() {
		return cdomings;
	}	
	public String getAlmanaque() {
		return almanaque;
	}

	public void setId(String id) {
		this.id = id;
	}
	public void setAny(int any) {
		this.any = any;
	}	
	public void setFestesDisp(List<FestiusTab> festesDisp) {
		this.festesDisp = festesDisp;
	}
	public void setCtfestiList(List<TipusFestius> ctfestiList) {
		this.ctfestiList = ctfestiList;
	}
	public void setFdataini(Date fdataini) {
		this.fdataini = fdataini;
	}	
	public void setFdatafin(Date fdatafin) {
		this.fdatafin = fdatafin;
	}	
	public void setFtfestiu(String ftfestiu) {
		this.ftfestiu = ftfestiu;
	}
	public void setFtfid (int ftfid) {
		this.ftfid = ftfid;
	}
	public void setFtfds (String ftfds) {
		this.ftfds = ftfds;
	}
	public void setCsabados (Boolean csabados) {
		this.csabados = csabados;
	}
	public void setCdomings (Boolean cdomings) {
		this.cdomings = cdomings;
	}	
	public void setAlmanaque(String almanaque) {
		this.almanaque = almanaque;
	}	

	
	public void preparar() {
		// Obtenir llista tipus festius
		this.ctfestiList = linkTfestiu.list();	

		// Any actual el que treballem		
		if (session.get("xworkany") == null) {
			workany = Calendar.getInstance();
		} else {
			workany = (Calendar)session.get("xworkany");			
		}
		setAny(workany.get(Calendar.YEAR));
		// Recuperem llista amb els festius del any		
		this.festesList = linkFestiu.list(getAny());
		// Carregar festius entrats
		setWfesta();
		// Generem calendari		
		this.setAlmanaque(almanaque(workany));
	
		// Mantenim calendari i any
		session.put("xalmanaque", almanaque);
		session.put("xworkany", workany);		
	}
	
	public void setPos() {
		this.posx[0] = "50px";   this.posy[0]="250px";  this.tit[0] = "efestiu.mes1";
		this.posx[1] = "200px";  this.posy[1]="250px";  this.tit[1] = "efestiu.mes2";
		this.posx[2] = "350px";  this.posy[2]="250px";  this.tit[2] = "efestiu.mes3";
		this.posx[3] = "500px";  this.posy[3]="250px";  this.tit[3] = "efestiu.mes4";
		this.posx[4] = "650px";  this.posy[4]="250px";  this.tit[4] = "efestiu.mes5";
		this.posx[5] = "800px";  this.posy[5]="250px";  this.tit[5] = "efestiu.mes6";
		this.posx[6] = "50px";   this.posy[6]="400px";  this.tit[6] = "efestiu.mes7";
		this.posx[7] = "200px";  this.posy[7]="400px";  this.tit[7] = "efestiu.mes8";
		this.posx[8] = "350px";  this.posy[8]="400px";  this.tit[8] = "efestiu.mes9";
		this.posx[9] = "500px";  this.posy[9]="400px";  this.tit[9] = "efestiu.mes10";
		this.posx[10] = "650px"; this.posy[10]="400px"; this.tit[10] = "efestiu.mes11";
		this.posx[11] = "800px"; this.posy[11]="400px"; this.tit[11] = "efestiu.mes12";		
		this.sem[0] = "efestiu.dias0";
		this.sem[1] = "efestiu.dias1";
		this.sem[2] = "efestiu.dias2";
		this.sem[3] = "efestiu.dias3";
		this.sem[4] = "efestiu.dias4";
		this.sem[5] = "efestiu.dias5";
		this.sem[6] = "efestiu.dias6";
		this.sem[7] = "efestiu.dias7";
	}
	public void setWfesta () {
		wfesta = new int [366];
		dfesta = new String [366];	
		dcolor = new String [366];				
		for (int i = 0; i<festesList.size();i++) {
//			Prepara les dades
			Calendar cini = Calendar.getInstance();
			Calendar cfin = Calendar.getInstance();			
			cini.setTime(festesList.get(i).getDataInici());
			cfin.setTime(festesList.get(i).getDataFi());
			Calendar c = cini;
			while (! c.getTime().after(cfin.getTime())){
				wfesta[c.get(Calendar.DAY_OF_YEAR) - 1] = festesList.get(i).getDTFestiu().getIdTFestiu();
				dfesta[c.get(Calendar.DAY_OF_YEAR) - 1] = festesList.get(i).getDTFestiu().getDescripcio();
				dcolor[c.get(Calendar.DAY_OF_YEAR) - 1] = festesList.get(i).getDTFestiu().getColor();				
				c.add(Calendar.DATE, 1);				
			}
		}
	}
	public String almanaque(Calendar work){
		this.almanaque = "";
		setPos();
		int omes = -1;
		int oweek = 0;
		String wini = "01-01-" + work.get(Calendar.YEAR);
		String wfin = "31-12-" + work.get(Calendar.YEAR);		
		SimpleDateFormat sdwini= new SimpleDateFormat("dd-MM-yyyy"); 
		SimpleDateFormat sdwfin= new SimpleDateFormat("dd-MM-yyyy"); 
		try {
//			Prepara les dades
			Calendar cini = Calendar.getInstance();
			Calendar cfin = Calendar.getInstance();			
			cini.setTime(sdwini.parse(wini));
			cfin.setTime(sdwfin.parse(wfin));
			Calendar c = cini;
			while (! c.getTime().after(cfin.getTime())){
				// Canvi de mes
				if (omes != c.get(Calendar.MONTH)) {
					if (omes != -1) {
						switch (c.get(Calendar.DAY_OF_WEEK)){
						case 3: this.almanaque = this.almanaque + "<td></td><td></td><td></td><td></td><td></td><td></td>"; break;
						case 4: this.almanaque = this.almanaque + "<td></td><td></td><td></td><td></td><td></td>";  break;
						case 5: this.almanaque = this.almanaque + "<td></td><td></td><td></td><td></td>";  break;
						case 6: this.almanaque = this.almanaque + "<td></td><td></td><td></td>";  break;
						case 7: this.almanaque = this.almanaque + "<td></td><td></td>";  break;
						case 1: this.almanaque = this.almanaque + "<td></td>";  break;
						}
						this.almanaque = this.almanaque + "</tr>\n</table>\n";
					}
					// nova taula
					this.almanaque = this.almanaque + "<table style=\"font-family:Calibri; font-size:12px;position: absolute;left:" + this.posx[c.get(Calendar.MONTH)]+";top:" + this.posy[c.get(Calendar.MONTH)]+";\">\n";
					// capalera
					this.almanaque = this.almanaque + "<tr><th align=center colspan=8>" + getText(tit[c.get(Calendar.MONTH)])+"</th></tr>\n";
					this.almanaque = this.almanaque + "<tr><td style=\"color:#FE9A2E;\">" + getText(sem[0]) + "</td><td style=\"color:#0101DF;\">" + getText(sem[1]) + "</td><td style=\"color:#0101DF;\">" + getText(sem[2]) + "</td><td style=\"color:#0101DF;\">" + getText(sem[3]) + "</td><td style=\"color:#0101DF;\">" + getText(sem[4]) + "</td><td style=\"color:#0101DF;\">" + getText(sem[5]) + "</td><td style=\"color:#0101DF;\">" + getText(sem[6]) + "</td><td style=\"color:#0101DF;\">" + getText(sem[7]) + "</td></tr>\n";
					omes = c.get(Calendar.MONTH);
					// provoquem un canvi de setmana
					oweek = 0;
				}
//				Canvi de setmana
				if (oweek != c.get(Calendar.WEEK_OF_YEAR)) {
					if (oweek != 0) this.almanaque = this.almanaque + "</tr>\n";
					switch (c.get(Calendar.DAY_OF_WEEK)){
					case 2: this.almanaque = this.almanaque + "<tr><td align=\"right\" style=\"color:#FF8000;\">" + c.get(Calendar.WEEK_OF_YEAR) + "</td>"; break;
					case 3: this.almanaque = this.almanaque + "<tr><td align=\"right\" style=\"color:#FF8000;\">" + c.get(Calendar.WEEK_OF_YEAR) + "</td><td></td>"; break;
					case 4: this.almanaque = this.almanaque + "<tr><td align=\"right\" style=\"color:#FF8000;\">" + c.get(Calendar.WEEK_OF_YEAR) + "</td><td></td><td></td>"; break;					
					case 5: this.almanaque = this.almanaque + "<tr><td align=\"right\" style=\"color:#FF8000;\">" + c.get(Calendar.WEEK_OF_YEAR) + "</td><td></td><td></td><td></td>"; break;
					case 6: this.almanaque = this.almanaque + "<tr><td align=\"right\" style=\"color:#FF8000;\">" + c.get(Calendar.WEEK_OF_YEAR) + "</td><td></td><td></td><td></td><td></td>"; break;	
					case 7: this.almanaque = this.almanaque + "<tr><td align=\"right\" style=\"color:#FF8000;\">" + c.get(Calendar.WEEK_OF_YEAR) + "</td><td></td><td></td><td></td><td></td><td></td>"; break;					
					case 1: this.almanaque = this.almanaque + "<tr><td align=\"right\" style=\"color:#FF8000;\">" + c.get(Calendar.WEEK_OF_YEAR) + "</td><td></td><td></td><td></td><td></td><td></td><td></td>"; break;
					}
					oweek = c.get(Calendar.WEEK_OF_YEAR);					
				}
				if (wfesta[c.get(Calendar.DAY_OF_YEAR) - 1] != 0) {
					SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
					this.almanaque = this.almanaque + "<td bgcolor=\"" + 
						dcolor[c.get(Calendar.DAY_OF_YEAR) - 1] + "\"  title = \"" + 
						dfesta[c.get(Calendar.DAY_OF_YEAR) - 1] + "\" align=\"right\" " + 
						"onclick=\"document.location.href = 'efestiuS?id=" +
						sdf.format(c.getTime())+ "'\" style=\"cursor:pointer\">" + 
						c.get(Calendar.DAY_OF_MONTH)+ "</td>";
				} else {
					this.almanaque = this.almanaque + "<td align=\"right\">" + c.get(Calendar.DAY_OF_MONTH)+ "</td>";
				}
				c.add(Calendar.DATE, 1);
			}
			switch (c.get(Calendar.DAY_OF_WEEK)){
			case 3: this.almanaque = this.almanaque + "<td></td><td></td><td></td><td></td><td></td><td></td>";  break;
			case 4: this.almanaque = this.almanaque + "<td></td><td></td><td></td><td></td><td></td>";  break;
			case 5: this.almanaque = this.almanaque + "<td></td><td></td><td></td><td></td>";  break;
			case 6: this.almanaque = this.almanaque + "<td></td><td></td><td></td>";  break;
			case 7: this.almanaque = this.almanaque + "<td></td><td></td>";  break;
			case 1: this.almanaque = this.almanaque + "<td></td>";  break;
			}
			this.almanaque = this.almanaque + "</tr>\n</table>\n";
//			System.out.println(this.almanaque);			
		} catch (ParseException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return almanaque;
	}
	
	public String preview() {
		workany = (Calendar)session.get("xworkany");
		setAny(workany.get(Calendar.YEAR));	
		this.festesList = linkFestiu.list(getAny());		
		for (int iter = 0; iter < this.festesList.size(); iter++) {
			this.festesDisp.add(
					new FestiusTab(
							this.festesList.get(iter).getDataInici(), 
							this.festesList.get(iter).getDataFi(),
							this.festesList.get(iter).getDTFestiu().getDescripcio(),
							"<a href=\"efestiuM?id=" + this.festesList.get(iter).getDataInici().toString()
							+ "\">" + getText("efestiu.label.upd") + "</a> | "
							+ "<a href=\"efestiuD?id=" + this.festesList.get(iter).getDataInici().toString()
							+ "\">" + getText("efestiu.label.del") + "</a>"
			));
		}		
		return SUCCESS;
	}
	
	public Boolean validation() {
		if (fdataini == null) {
			addActionError(getText("efestiu.error.1"));
			return false;			
		}
		if (fdatafin == null) {
			addActionError(getText("efestiu.error.2"));
			return false;			
		}
		if (fdataini.after(fdatafin)) {
			addActionError(getText("efestiu.error.3"));
			return false;
		}
		if (linkFestiu.check(new java.sql.Date(fdataini.getTime()),new java.sql.Date(fdatafin.getTime())) != 0) {
			addActionError(getText("efestiu.error.4"));
			return false;						
		}
		if (ftfestiu == null || ftfestiu.equals("0")) {
			addActionError(getText("efestiu.error.5"));
			return false;			
		}
		return true;
	}

	public Boolean validationMod() {
		if (fdatafin == null) {
			addActionError(getText("efestiu.error.2"));
			return false;			
		}
		if (fdataini.after(fdatafin)) {
			addActionError(getText("efestiu.error.3"));
			return false;
		}
		if (linkFestiu.check(new java.sql.Date(fdataini.getTime()),new java.sql.Date(fdatafin.getTime())) != 1) {
			addActionError(getText("efestiu.error.4"));
			return false;						
		}
		if (ftfestiu == null || ftfestiu.equals("0")) {
			addActionError(getText("efestiu.error.5"));
			return false;			
		}
		return true;
	}	
}
