package tornodrom.view;

import java.util.Date;
import java.sql.Time;
import java.sql.Timestamp;
import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.List;
import java.util.Map;

import tornodrom.control.EmpleatManager;
import tornodrom.control.IdentificatiuManager;
import tornodrom.control.ResponsableManager;
import tornodrom.list.EmpleatsTab;
import tornodrom.list.ResponsablesSel;
import tornodrom.list.ResponsablesTab;
import tornodrom.model.Empleats;
import tornodrom.model.Identificatius;
import tornodrom.model.Responsables;
import tornodrom.model.ResponsablesPk;

import com.opensymphony.xwork2.ActionContext;
import com.opensymphony.xwork2.ActionSupport;

public class EjerarqAction extends ActionSupport {

	private int id;
	
	private EmpleatManager linkEmpleat;
	private List<Empleats> empleatList;
	ArrayList<EmpleatsTab> lista;
	private List empleatDisp = new ArrayList();	

	private ResponsableManager linkResp;
	private List<Responsables> respList;
	ArrayList<ResponsablesTab> lista_rsp;
	private List respDisp = new ArrayList();
	
	private Map session;
	
	private Empleats empleat;
	private String gnom;

	private String vrsp;
	private Date vdin;
	private List<Empleats> emprespList;
	ArrayList<ResponsablesSel> rsp_sel;
	private List respSel = new ArrayList();
	
	private Responsables resp;
	private ResponsablesPk respPk;
	private Responsables respant;
	
	public EjerarqAction() {
		linkEmpleat = new EmpleatManager();
		linkResp = new ResponsableManager();
		session = ActionContext.getContext().getSession();
	}	
	
	public String execute() {
		return SUCCESS;
	}

	public String llista() {
		this.empleatList = linkEmpleat.listAll();
		for (int iter = 0; iter < this.empleatList.size(); iter++) {
			this.empleatDisp.add(
					new EmpleatsTab(
							this.empleatList.get(iter).getIdEmpleat(), 
							this.empleatList.get(iter).getNIdentificacio(),
							this.empleatList.get(iter).getNom() + " " +
							this.empleatList.get(iter).getPCognom() + " " +
							this.empleatList.get(iter).getSCognom(),
							this.empleatList.get(iter).getTelefon(),
							this.empleatList.get(iter).getCorreu(),
							this.empleatList.get(iter).getDataIncorporacio(),
							this.empleatList.get(iter).getDataBaixa(),
							"<a href=\"ejerarqV?id=" + this.empleatList.get(iter).getIdEmpleat()
							+ "\">" + getText("ejerarq.label.det") + "</a>"
			));
		}
		return SUCCESS;
	}

	public String llista_resp() {
		if (getId()==0) setId((Integer)session.get("xjempid"));
		empleat = linkEmpleat.find(getId());
		setGnom(empleat.getNom() + " " + empleat.getPCognom());
		session.put("xjempid", getId());
		session.put("xjempnom", getGnom());
		this.respList = linkResp.list(getId());
		for (int iter = 0; iter < this.respList.size(); iter++) {
			this.respDisp.add(
					new ResponsablesTab(
							this.respList.get(iter).getId().getDResponsable().getIdEmpleat(), 
							this.respList.get(iter).getId().getDResponsable().getNom() + " " +
							this.respList.get(iter).getId().getDResponsable().getPCognom() + " " +
							this.respList.get(iter).getId().getDResponsable().getSCognom(),
							this.respList.get(iter).getId().getDataInici(),
							this.respList.get(iter).getDataFi()
			));
		}
		return SUCCESS;
	}
	
	public String preadd() {
		setGnom((String)session.get("xjempnom"));
		responsables();
		return SUCCESS;
	}
	public String add() {
		setId((Integer)session.get("xjempid"));
		setGnom((String)session.get("xjempnom"));
		responsables();
		this.respList = linkResp.ultim(getId());
		this.respant = respList.get(0);
		if (validation()) {
			// Fecha final del anterior periodo
			Calendar vdfi = Calendar.getInstance();
			vdfi.setTime(vdin);
			vdfi.add(Calendar.DATE, -1);
			respant.setDataFi(new java.sql.Date(vdfi.getTime().getTime()));
			linkResp.update(respant);
			// Nuevo periodo
			resp = new Responsables();
			respPk = new ResponsablesPk(getId(),Integer.parseInt(vrsp),new java.sql.Date(getVdin().getTime()));
			respPk.setDEmpleat(linkEmpleat.find(getId()));
			respPk.setDResponsable(linkEmpleat.find(Integer.parseInt(vrsp)));
			resp.setId(respPk);
			resp.setUsuariAlta((String)session.get("xusuari"));
			resp.setTmstmpAlta(new Timestamp(Calendar.getInstance().getTime().getTime()));
			linkResp.add(resp);			
			return SUCCESS;
		} else {
			return ERROR;
		}
	}

	public int getId () {
		return id;
	}
	public List<EmpleatsTab> getEmpleatDisp() {
		return empleatDisp;
	}
	public List<ResponsablesTab> getRespDisp() {
		return respDisp;
	}
	public String getGnom(){
		return gnom;
	}
	public List<ResponsablesSel> getRespSel() {
		return respSel;
	}
	public String getVrsp(){
		return vrsp;
	}
	public Date getVdin(){
		return vdin;
	}
	
	public void setId (int id){
		this.id = id;
	}
	public void setEmpleatDisp(List<EmpleatsTab> empleatDisp) {
		this.empleatDisp = empleatDisp;
	}	
	public void setRespDisp(List<ResponsablesTab> respDisp) {
		this.respDisp = respDisp;
	}
	public void setGnom (String gnom) {
		this.gnom = gnom;
	}
	public void setRespSel(List<ResponsablesSel> respSel) {
		this.respSel = respSel;
	}
	public void setVrsp (String vrsp) {
		this.vrsp = vrsp;
	}
	public void setVdin (Date vdin) {
		this.vdin = vdin;
	}
	
	public Boolean validation() {
		if (vrsp.equals("0")) {
			addActionError(getText("ejerarq.error.1"));
			return false;			
		}
		if (Integer.parseInt(vrsp) == respant.getId().getDResponsable().getIdEmpleat()) {
			addActionError(getText("ejerarq.error.2"));
			return false;			
		}
		if (vdin == null) {
			addActionError(getText("ejerarq.error.3"));
			return false;
		}
		if (vdin.before(new java.util.Date(respant.getId().getDataInici().getTime()))) {
			addActionError(getText("ejerarq.error.4"));
			return false;			
		}
		if (vdin.equals(new java.util.Date(respant.getId().getDataInici().getTime()))) {
			addActionError(getText("ejerarq.error.4"));
			return false;			
		}
		return true;
	}
	
	public void responsables() {
		this.emprespList = linkEmpleat.listResp();
		for (int iter = 0; iter < this.emprespList.size(); iter++) {
			this.respSel.add(
				new ResponsablesSel(
					this.emprespList.get(iter).getIdEmpleat(),
					this.emprespList.get(iter).getNom() + " " +
					this.emprespList.get(iter).getPCognom()
			));
		}		
	}
}
