package tornodrom.view;

import java.sql.Timestamp;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.List;
import java.util.Map;
import java.util.Date;

import tornodrom.control.CalendariManager;
import tornodrom.control.FestiuManager;
import tornodrom.control.TipuscalendariManager;
import tornodrom.control.TipustornManager;
import tornodrom.list.CalendarisTab;
import tornodrom.list.TipusCalendarisTab;
import tornodrom.model.Calendaris;
import tornodrom.model.CalendarisPk;
import tornodrom.model.Festius;
import tornodrom.model.TipusCalendaris;
import tornodrom.model.TipusTorns;

import com.opensymphony.xwork2.ActionContext;
import com.opensymphony.xwork2.ActionSupport;

public class EturnosAction extends ActionSupport {

	private Map session;
	private TipuscalendariManager linkTcalendari;
	List <TipusCalendaris> listTcal;
	ArrayList<TipusCalendarisTab> listacal;
	private List tcalDisp = new ArrayList();

	private String vclid;
	private String vclsq;
	private int vclan;
	private Boolean vclfs;
	
	private CalendariManager linkCalendari;
	private TipustornManager linkTtorn;
	
	private List<Calendaris> calendariList;
	private List<TipusTorns> ttornList;
	ArrayList<Calendaris> lista;
	private List calendariDisp = new ArrayList();
	
	private FestiuManager linkFestiu;
	private List<Festius> festiuList;
	private int[] wfesta = new int [366];
	private int[] wwork=new int [366];
	
	private Calendaris calendari;
	private CalendarisPk calendariPk;

	private int id;
	private String tipus;
	private int any;
	private Calendar workany;
	
	private int[] wtrn = new int [366];
	private String [] dtrn = new String [366];
	private String [] dcolor = new String [366];
	private int[] wfst = new int [366];
	private String [] dfst = new String [366];
	private String [] fcolor = new String [366];
	private String almanaque;
	private String[] posx = new String [12];
	private String[] posy = new String [12];
	private String[] tit = new String [12];
	private String[] sem = new String [8];

	private String df;
	private Date fdataini;
	private Date fdatafin;
	private String fttorn;
	
	private int fttid;
	private String fttds;
	
	public EturnosAction() {
		linkTcalendari = new TipuscalendariManager();
		linkCalendari = new CalendariManager();
		linkTtorn = new TipustornManager();
		linkFestiu = new FestiuManager();
		session = ActionContext.getContext().getSession();		
	}	
	
	public String execute() {
		return SUCCESS;
	}

	public String carregar(){
		// Recuperem llista amb calendaris		
		this.listTcal = linkTcalendari.list();
		for (int iter = 0; iter < this.listTcal.size(); iter++) {
			this.tcalDisp.add(
					new TipusCalendarisTab(
							this.listTcal.get(iter).getIdTCalendari(),
							this.listTcal.get(iter).getDescripcio(),
							"<a href=\"eturnosC?id=" + this.listTcal.get(iter).getIdTCalendari()
							+ "\">" + getText("eturnos.label.det") + "</a>"
			));
		}
		return SUCCESS;
	}

	public String previ_gen() {
		// Recuperem llista amb calendaris		
		this.listTcal = linkTcalendari.list();
		return SUCCESS;
	}
	
	public String generar() {
		this.listTcal = linkTcalendari.list();
		ttornList = linkTtorn.list();
		if (!validationGen()) return ERROR;
		secuenciar();
		return SUCCESS;
	}
	
	public String detall(){
		// Obtenir llista tipus torns
		this.ttornList = linkTtorn.list();

		if (getId() == 0) setId((Integer)session.get("xidcal"));
		// Any actual el que treballem		
		if (session.get("xworkany") == null) {
			workany = Calendar.getInstance();
		} else {
			workany = (Calendar)session.get("xworkany");			
		}
		setAny(workany.get(Calendar.YEAR));
		// Recuperem llista amb els torns del any i carreguem
		this.calendariList = linkCalendari.list(getId(),getAny());
		setWtorn();
		// Recuperem llista amb els festius del any i carreguem
		this.festiuList = linkFestiu.list(getAny());
		setWfest();		
		// Generem calendari		
		this.setAlmanaque(almanaque(workany));
		setTipus(linkTcalendari.find(getId()).getDescripcio());
		// Mantenim calendari i any
		session.put("xalmanaque", almanaque);
		session.put("xworkany", workany);
		session.put("xidcal",getId());
		return SUCCESS;
	}
	
	public String restar() {
		this.ttornList = linkTtorn.list();

		workany = (Calendar)session.get("xworkany");
		workany.add(Calendar.YEAR, -1);

		session.put("xalmanaque", almanaque);
		session.put("xworkany", workany);
		return SUCCESS;
	}	
	public String sumar() {
		this.ttornList = linkTtorn.list();

		workany = (Calendar)session.get("xworkany");
		workany.add(Calendar.YEAR, 1);

		session.put("xalmanaque", almanaque);
		session.put("xworkany", workany);
		return SUCCESS;
	}		
	public String ver() {
		// Obtenir llista tipus torns
		ttornList = linkTtorn.list();
		workany = (Calendar)session.get("xworkany");
		setAny(workany.get(Calendar.YEAR));	
		SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
		try {
			Date d = sdf.parse(getDf());
			setId((Integer)session.get("xidcal"));
			setTipus(linkTcalendari.find(getId()).getDescripcio());
			calendariList = linkCalendari.view(getId(), new java.sql.Date(d.getTime()));
			setFdataini(calendariList.get(0).getId().getDataInici());
			setFdatafin(calendariList.get(0).getDataFi());
			setFttorn(calendariList.get(0).getDTTorn().getDescripcio());
			setFttid(calendariList.get(0).getDTTorn().getIdTTorn());
			setFttds(calendariList.get(0).getDTTorn().getDescripcio());
			return SUCCESS;
		} catch (ParseException ex) {
			ex.printStackTrace();
			return ERROR;
		}
	}
	public String tornar() {
		return SUCCESS;
	}

	public String preview() {
		calendariDisp = new ArrayList();
		setId((Integer)session.get("xidcal"));
		setTipus(linkTcalendari.find(getId()).getDescripcio());
		workany = (Calendar)session.get("xworkany");
		setAny(workany.get(Calendar.YEAR));	
		// Recuperem llista amb calendaris		
		this.calendariList = linkCalendari.list(id,any);
		for (int iter = 0; iter < this.calendariList.size(); iter++) {
			this.calendariDisp.add(
					new CalendarisTab(
							this.calendariList.get(iter).getId().getDCalendari().getIdTCalendari(),
							this.calendariList.get(iter).getId().getDCalendari().getDescripcio(),
							this.calendariList.get(iter).getId().getDataInici(),
							this.calendariList.get(iter).getDataFi(),
							this.calendariList.get(iter).getDTTorn().getDescripcio(),
							"<a href=\"eturnosM?df=" + this.calendariList.get(iter).getId().getDataInici().toString()
							+ "\">" + getText("eturnosv.label.upd") + "</a> | "
							+ "<a href=\"eturnosD?df=" + this.calendariList.get(iter).getId().getDataInici().toString()
							+ "\">" + getText("eturnosv.label.del") + "</a>"
			));
		}	
		return SUCCESS;
	}

	public String preadd() {
		// Obtenir llista tipus torns
		ttornList = linkTtorn.list();
		workany = (Calendar)session.get("xworkany");			
		setAny(workany.get(Calendar.YEAR));	
		setId((Integer)session.get("xidcal"));		
		setTipus(linkTcalendari.find(getId()).getDescripcio());
		return SUCCESS;
	}
	public String add() {
		// Obtenir llista tipus torns
		ttornList = linkTtorn.list();
		workany = (Calendar)session.get("xworkany");			
		setAny(workany.get(Calendar.YEAR));	
		setId((Integer)session.get("xidcal"));
		// Filtrar dades
		if (!validation()) return ERROR;
		calendariPk = new CalendarisPk(getId(),new java.sql.Date(getFdataini().getTime()));
		calendariPk.setDCalendari(linkTcalendari.find(getId()));
		calendari = linkCalendari.find(calendariPk);
		if (null != calendari) {
			// Si existeix modificar
			calendari.setDataFi(new java.sql.Date(fdatafin.getTime()));
			calendari.setDTTorn(linkTtorn.find(Integer.parseInt(fttorn)));
			calendari.setUsuariModi((String)session.get("xusuari"));
			calendari.setTmstmpModi(new Timestamp(Calendar.getInstance().getTime().getTime()));
			if (calendari.getTmstmpBaja() != null) {
				calendari.setUsuariBaja(null);
				calendari.setTmstmpBaja(null);
			}
			linkCalendari.update(calendari);
		} else {
			// Sino existeix donar d'alta
			calendari = new Calendaris();
			calendariPk = new CalendarisPk(getId(),new java.sql.Date(getFdataini().getTime()));
			calendariPk.setDCalendari(linkTcalendari.find(getId()));
			calendari.setId(calendariPk);
			calendari.setDataFi(new java.sql.Date(fdatafin.getTime()));
			calendari.setDTTorn(linkTtorn.find(Integer.parseInt(fttorn)));
			calendari.setUsuariAlta((String)session.get("xusuari"));
			calendari.setTmstmpAlta(new Timestamp(Calendar.getInstance().getTime().getTime()));
			linkCalendari.add(calendari);
		}
		return SUCCESS;
	}
	public String mod() {
		// Obtenir llista tipus torns
		ttornList = linkTtorn.list();
		workany = (Calendar)session.get("xworkany");			
		setAny(workany.get(Calendar.YEAR));	
		setId((Integer)session.get("xidcal"));
		setTipus(linkTcalendari.find(getId()).getDescripcio());
		// Filtrar dades
		if (!validationMod()) return ERROR;
		calendariPk = new CalendarisPk(getId(),new java.sql.Date(getFdataini().getTime()));
		calendariPk.setDCalendari(linkTcalendari.find(getId()));
		calendari = linkCalendari.find(calendariPk);
		// Si existeix modificar
		calendari.setDataFi(new java.sql.Date(fdatafin.getTime()));
		calendari.setDTTorn(linkTtorn.find(Integer.parseInt(fttorn)));
		calendari.setUsuariModi((String)session.get("xusuari"));
		calendari.setTmstmpModi(new Timestamp(Calendar.getInstance().getTime().getTime()));
		if (calendari.getTmstmpBaja() != null) {
			calendari.setUsuariBaja(null);
			calendari.setTmstmpBaja(null);
		}
		linkCalendari.update(calendari);
		return SUCCESS;		
	}
	public String del() {
		setId((Integer)session.get("xidcal"));
		setTipus(linkTcalendari.find(getId()).getDescripcio());
		calendariPk = new CalendarisPk(getId(),new java.sql.Date(getFdataini().getTime()));
		calendariPk.setDCalendari(linkTcalendari.find(getId()));
		calendari = linkCalendari.find(calendariPk);
		calendari.setUsuariBaja((String)session.get("xusuari"));
		calendari.setTmstmpBaja(new Timestamp(Calendar.getInstance().getTime().getTime()));
		linkCalendari.update(calendari);
		return SUCCESS;
	}
	
	public List<TipusCalendarisTab> getTcalDisp() {
		return tcalDisp;
	}
	public List<TipusCalendaris> getListTcal() {
		return listTcal;
	}
	public String getVclid(){
		return vclid;
	}
	public String getVclsq(){
		return vclsq;
	}
	public int getVclan(){
		return vclan;
	}
	public Boolean getVclfs(){
		return vclfs;
	}
	public List<CalendarisTab> getCalendariDisp() {
		return calendariDisp;
	}
	public int getId() {
		return id;
	}
	public String getTipus() {
		return tipus;
	}
	public int getAny() {
		return any;
	}
	public String getAlmanaque() {
		return almanaque;
	}
	public String getDf() {
		return df;
	}
	public Date getFdataini() {
		return fdataini;
	}
	public Date getFdatafin() {
		return fdatafin;
	}	
	public String getFttorn() {
		return fttorn;
	}
	public List<TipusTorns> getTtornList() {
		return ttornList;
	}
	public int getFttid() {
		return fttid;
	}
	public String getFttds() {
		return fttds;
	}
	
	public void setTcalDisp(List<TipusCalendarisTab> tcalDisp) {
		this.tcalDisp = tcalDisp;
	}
	public void setListTcal(List<TipusCalendaris> listTcal) {
		this.listTcal = listTcal;
	}
	public void setVclid(String vclid) {
		this.vclid = vclid;
	}
	public void setVclsq(String vclsq) {
		this.vclsq = vclsq;
	}
	public void setVclan(int vclan) {
		this.vclan = vclan;
	}
	public void setVclfs(Boolean vclfs) {
		this.vclfs = vclfs;
	}
	public void setCalendariDisp(List<CalendarisTab> calendariDisp) {
		this.calendariDisp = calendariDisp;
	}
	public void setId(int id) {
		this.id = id;
	}
	public void setTipus(String tipus) {
		this.tipus = tipus;
	}
	public void setAny(int any) {
		this.any = any;
	}
	public void setAlmanaque(String almanaque) {
		this.almanaque = almanaque;
	}
	public void setDf(String df) {
		this.df = df;
	}
	public void setFdataini(Date fdataini) {
		this.fdataini = fdataini;
	}	
	public void setFdatafin(Date fdatafin) {
		this.fdatafin = fdatafin;
	}	
	public void setFttorn(String fttorn) {
		this.fttorn = fttorn;
	}
	public void setTtornList(List<TipusTorns> ttornList) {
		this.ttornList = ttornList;
	}
	public void setFttid (int fttid) {
		this.fttid = fttid;
	}
	public void setFttds (String fttds) {
		this.fttds = fttds;
	}

	public Boolean validationGen() {
		if (getVclid() == null || getVclid().trim().equals("")) {
			addActionError(getText("eturnosg.error.1"));
			return false;			
		}
		if (getVclsq() == null || getVclsq().trim().equals("")) {
			addActionError(getText("eturnosg.error.2"));
			return false;			
		}
		for (int i = 0; i < getVclsq().length(); i++) {
			Boolean chk = false;
			for (int j = 0; j < ttornList.size(); j++) {
				if (getVclsq().substring(i,i+1).equals(Integer.toString(ttornList.get(j).getIdTTorn()))) {
					chk = true;
					break;
				}
			}
			if (!chk) {
				addActionError(getText("eturnosg.error.3"));
				return chk;
			}
		}
		if (getVclan() < 1975 || getVclan() > 2150) {
			addActionError(getText("eturnosg.error.4"));
			return false;			
		}
		if (linkCalendari.checkAny(Integer.parseInt(vclid), vclan) != 0) {
			addActionError(getText("eturnosg.error.5"));
			return false;			
		}
		return true;
	}
	
	public void secuenciar() {
		if (vclfs) festivos();
		wwork = new int [366];
		int j=0;
		for (int i=0; i<366;i++){
			wwork[i]=Integer.parseInt(getVclsq().substring(j, j+1));
			j++;
			if (j>=getVclsq().length()) j=0;
		}
		String wini = "01-01-" + getVclan();
		String wfin = "31-12-" + getVclan();		
		SimpleDateFormat sdwini= new SimpleDateFormat("dd-MM-yyyy"); 
		SimpleDateFormat sdwfin= new SimpleDateFormat("dd-MM-yyyy");
		try {
//		Prepara les dades
			Calendar cini = Calendar.getInstance();
			Calendar cfin = Calendar.getInstance();			
			cini.setTime(sdwini.parse(wini));
			cfin.setTime(sdwfin.parse(wfin));
			Calendar c = cini;
			Boolean iniper = true;
			while (! c.getTime().after(cfin.getTime())){
				if (wfesta[c.get(Calendar.DAY_OF_YEAR) - 1] != 1){
					if (iniper) {
						calendari = new Calendaris();
						calendariPk = new CalendarisPk(Integer.parseInt(vclid),new java.sql.Date(c.getTime().getTime()));
						calendariPk.setDCalendari(linkTcalendari.find(Integer.parseInt(vclid)));
						calendari.setId(calendariPk);
						iniper = false;
					}
					calendari.setDataFi(new java.sql.Date(c.getTime().getTime()));
					calendari.setDTTorn(linkTtorn.find(wwork[c.get(Calendar.DAY_OF_YEAR) - 1]));
					calendari.setUsuariAlta((String)session.get("xusuari"));
					calendari.setTmstmpAlta(new Timestamp(Calendar.getInstance().getTime().getTime()));
					if ((c.getTime().before(cfin.getTime()) && 
							(wwork[c.get(Calendar.DAY_OF_YEAR) - 1] != wwork[c.get(Calendar.DAY_OF_YEAR)]))
							|| wfesta[c.get(Calendar.DAY_OF_YEAR)] == 1) {
						linkCalendari.add(calendari);
						iniper=true;
					}
				}
				c.add(Calendar.DATE, 1);				
			}
			if (wfesta[cfin.get(Calendar.DAY_OF_YEAR) - 1] != 1) {
				linkCalendari.add(calendari);
			}
		} catch (ParseException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}	
	}

	public void festivos() {
		Calendar fini = Calendar.getInstance();
		Calendar ffin = Calendar.getInstance();
		int dia_any = 0;
		int dif_dies = 0;
		wfesta = new int [366];
		festiuList = linkFestiu.list(vclan);
		for (int iter = 0; iter < this.festiuList.size(); iter++) {
			fini.setTime(festiuList.get(iter).getDataInici());
			ffin.setTime(festiuList.get(iter).getDataFi());
			dia_any = fini.get(Calendar.DAY_OF_YEAR) - 1;
			dif_dies = ffin.get(Calendar.DAY_OF_YEAR) - fini.get(Calendar.DAY_OF_YEAR);
			for (int i=dia_any;i<=dia_any + dif_dies;i++) {
				wfesta[i]=1;
			}
		}
	}

	public void setWtorn() {
		wtrn = new int [366];
		dtrn = new String [366];	
		dcolor = new String [366];	
		for (int i=0;i<calendariList.size();i++){
//			Prepara les dades
			Calendar cini = Calendar.getInstance();
			Calendar cfin = Calendar.getInstance();
			cini.setTime(calendariList.get(i).getId().getDataInici());
			cfin.setTime(calendariList.get(i).getDataFi());
			Calendar c = cini;
			while (! c.getTime().after(cfin.getTime())){
				wtrn[c.get(Calendar.DAY_OF_YEAR) - 1] = calendariList.get(i).getDTTorn().getIdTTorn();
				dtrn[c.get(Calendar.DAY_OF_YEAR) - 1] = calendariList.get(i).getDTTorn().getDescripcio();
				dcolor[c.get(Calendar.DAY_OF_YEAR) - 1] = calendariList.get(i).getDTTorn().getColor();				
				c.add(Calendar.DATE, 1);	
			}
		}
	}

	public void setWfest() {
		wfst = new int [366];
		dfst = new String [366];	
		fcolor = new String [366];	
		for (int i=0;i<festiuList.size();i++){
//			Prepara les dades
			Calendar cini = Calendar.getInstance();
			Calendar cfin = Calendar.getInstance();
			cini.setTime(festiuList.get(i).getDataInici());
			cfin.setTime(festiuList.get(i).getDataFi());
			Calendar c = cini;
			while (! c.getTime().after(cfin.getTime())){
				wfst[c.get(Calendar.DAY_OF_YEAR) - 1] = festiuList.get(i).getDTFestiu().getIdTFestiu();
				dfst[c.get(Calendar.DAY_OF_YEAR) - 1] = festiuList.get(i).getDTFestiu().getDescripcio();
				fcolor[c.get(Calendar.DAY_OF_YEAR) - 1] = festiuList.get(i).getDTFestiu().getColor();				
				c.add(Calendar.DATE, 1);	
			}
		}
	}
	
	public String almanaque(Calendar work){
		this.almanaque = "";
		setPos();
		int omes = -1;
		int oweek = 0;
		String wini = "01-01-" + work.get(Calendar.YEAR);
		String wfin = "31-12-" + work.get(Calendar.YEAR);		
		SimpleDateFormat sdwini= new SimpleDateFormat("dd-MM-yyyy"); 
		SimpleDateFormat sdwfin= new SimpleDateFormat("dd-MM-yyyy"); 
		try {
//			Prepara les dades
			Calendar cini = Calendar.getInstance();
			Calendar cfin = Calendar.getInstance();			
			cini.setTime(sdwini.parse(wini));
			cfin.setTime(sdwfin.parse(wfin));
			Calendar c = cini;
			while (! c.getTime().after(cfin.getTime())){
				// Canvi de mes
				if (omes != c.get(Calendar.MONTH)) {
					if (omes != -1) {
						switch (c.get(Calendar.DAY_OF_WEEK)){
						case 3: this.almanaque = this.almanaque + "<td></td><td></td><td></td><td></td><td></td><td></td>"; break;
						case 4: this.almanaque = this.almanaque + "<td></td><td></td><td></td><td></td><td></td>";  break;
						case 5: this.almanaque = this.almanaque + "<td></td><td></td><td></td><td></td>";  break;
						case 6: this.almanaque = this.almanaque + "<td></td><td></td><td></td>";  break;
						case 7: this.almanaque = this.almanaque + "<td></td><td></td>";  break;
						case 1: this.almanaque = this.almanaque + "<td></td>";  break;
						}
						this.almanaque = this.almanaque + "</tr>\n</table>\n";
					}
					// nova taula
					this.almanaque = this.almanaque + "<table style=\"font-family:Calibri; font-size:12px;position: absolute;left:" + this.posx[c.get(Calendar.MONTH)]+";top:" + this.posy[c.get(Calendar.MONTH)]+";\">\n";
					// capalera
					this.almanaque = this.almanaque + "<tr><th align=center colspan=8>" + getText(tit[c.get(Calendar.MONTH)])+"</th></tr>\n";
					this.almanaque = this.almanaque + "<tr><td style=\"color:#FE9A2E;\">" + getText(sem[0]) + "</td><td style=\"color:#0101DF;\">" + getText(sem[1]) + "</td><td style=\"color:#0101DF;\">" + getText(sem[2]) + "</td><td style=\"color:#0101DF;\">" + getText(sem[3]) + "</td><td style=\"color:#0101DF;\">" + getText(sem[4]) + "</td><td style=\"color:#0101DF;\">" + getText(sem[5]) + "</td><td style=\"color:#0101DF;\">" + getText(sem[6]) + "</td><td style=\"color:#0101DF;\">" + getText(sem[7]) + "</td></tr>\n";
					omes = c.get(Calendar.MONTH);
					// provoquem un canvi de setmana
					oweek = 0;
				}
//				Canvi de setmana
				if (oweek != c.get(Calendar.WEEK_OF_YEAR)) {
					if (oweek != 0) this.almanaque = this.almanaque + "</tr>\n";
					switch (c.get(Calendar.DAY_OF_WEEK)){
					case 2: this.almanaque = this.almanaque + "<tr><td align=\"right\" style=\"color:#FF8000;\">" + c.get(Calendar.WEEK_OF_YEAR) + "</td>"; break;
					case 3: this.almanaque = this.almanaque + "<tr><td align=\"right\" style=\"color:#FF8000;\">" + c.get(Calendar.WEEK_OF_YEAR) + "</td><td></td>"; break;
					case 4: this.almanaque = this.almanaque + "<tr><td align=\"right\" style=\"color:#FF8000;\">" + c.get(Calendar.WEEK_OF_YEAR) + "</td><td></td><td></td>"; break;					
					case 5: this.almanaque = this.almanaque + "<tr><td align=\"right\" style=\"color:#FF8000;\">" + c.get(Calendar.WEEK_OF_YEAR) + "</td><td></td><td></td><td></td>"; break;
					case 6: this.almanaque = this.almanaque + "<tr><td align=\"right\" style=\"color:#FF8000;\">" + c.get(Calendar.WEEK_OF_YEAR) + "</td><td></td><td></td><td></td><td></td>"; break;	
					case 7: this.almanaque = this.almanaque + "<tr><td align=\"right\" style=\"color:#FF8000;\">" + c.get(Calendar.WEEK_OF_YEAR) + "</td><td></td><td></td><td></td><td></td><td></td>"; break;					
					case 1: this.almanaque = this.almanaque + "<tr><td align=\"right\" style=\"color:#FF8000;\">" + c.get(Calendar.WEEK_OF_YEAR) + "</td><td></td><td></td><td></td><td></td><td></td><td></td>"; break;
					}
					oweek = c.get(Calendar.WEEK_OF_YEAR);					
				}
				if (wtrn[c.get(Calendar.DAY_OF_YEAR) - 1] != 0) {
					if (wfst[c.get(Calendar.DAY_OF_YEAR) - 1] != 0) {
						SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
						this.almanaque = this.almanaque + "<td bgcolor=\"" + 
							dcolor[c.get(Calendar.DAY_OF_YEAR) - 1] + "\"  title = \"" + 
							dtrn[c.get(Calendar.DAY_OF_YEAR) - 1] + " - " + dfst[c.get(Calendar.DAY_OF_YEAR) - 1] + 
							"\" align=\"right\" " + 
							"onclick=\"document.location.href = 'eturnosS?df=" +
							sdf.format(c.getTime())+ "'\" style=\"border: solid 0 #000; border-bottom-width:2px; cursor:pointer\">" + 
							c.get(Calendar.DAY_OF_MONTH)+ "</td>";						
					} else {
						SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
						this.almanaque = this.almanaque + "<td bgcolor=\"" + 
							dcolor[c.get(Calendar.DAY_OF_YEAR) - 1] + "\"  title = \"" + 
							dtrn[c.get(Calendar.DAY_OF_YEAR) - 1] + "\" align=\"right\" " + 
							"onclick=\"document.location.href = 'eturnosS?df=" +
							sdf.format(c.getTime())+ "'\" style=\"cursor:pointer\">" + 
							c.get(Calendar.DAY_OF_MONTH)+ "</td>";
					}
				} else {
					if (wfst[c.get(Calendar.DAY_OF_YEAR) - 1] != 0) {
						SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
						this.almanaque = this.almanaque + "<td bgcolor=\"" + 
							fcolor[c.get(Calendar.DAY_OF_YEAR) - 1] + "\"  title = \"" + 
							dfst[c.get(Calendar.DAY_OF_YEAR) - 1] + "\" align=\"right\">" + 
							c.get(Calendar.DAY_OF_MONTH)+ "</td>";						
					} else {
						this.almanaque = this.almanaque + "<td align=\"right\">" + c.get(Calendar.DAY_OF_MONTH)+ "</td>";
					}
				}
				c.add(Calendar.DATE, 1);
			}
			switch (c.get(Calendar.DAY_OF_WEEK)){
			case 3: this.almanaque = this.almanaque + "<td></td><td></td><td></td><td></td><td></td><td></td>";  break;
			case 4: this.almanaque = this.almanaque + "<td></td><td></td><td></td><td></td><td></td>";  break;
			case 5: this.almanaque = this.almanaque + "<td></td><td></td><td></td><td></td>";  break;
			case 6: this.almanaque = this.almanaque + "<td></td><td></td><td></td>";  break;
			case 7: this.almanaque = this.almanaque + "<td></td><td></td>";  break;
			case 1: this.almanaque = this.almanaque + "<td></td>";  break;
			}
			this.almanaque = this.almanaque + "</tr>\n</table>\n";
//			System.out.println(this.almanaque);			
		} catch (ParseException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return almanaque;
	}	

	public void setPos() {
		this.posx[0] = "50px";   this.posy[0]="250px";  this.tit[0] = "efestiu.mes1";
		this.posx[1] = "200px";  this.posy[1]="250px";  this.tit[1] = "efestiu.mes2";
		this.posx[2] = "350px";  this.posy[2]="250px";  this.tit[2] = "efestiu.mes3";
		this.posx[3] = "500px";  this.posy[3]="250px";  this.tit[3] = "efestiu.mes4";
		this.posx[4] = "650px";  this.posy[4]="250px";  this.tit[4] = "efestiu.mes5";
		this.posx[5] = "800px";  this.posy[5]="250px";  this.tit[5] = "efestiu.mes6";
		this.posx[6] = "50px";   this.posy[6]="400px";  this.tit[6] = "efestiu.mes7";
		this.posx[7] = "200px";  this.posy[7]="400px";  this.tit[7] = "efestiu.mes8";
		this.posx[8] = "350px";  this.posy[8]="400px";  this.tit[8] = "efestiu.mes9";
		this.posx[9] = "500px";  this.posy[9]="400px";  this.tit[9] = "efestiu.mes10";
		this.posx[10] = "650px"; this.posy[10]="400px"; this.tit[10] = "efestiu.mes11";
		this.posx[11] = "800px"; this.posy[11]="400px"; this.tit[11] = "efestiu.mes12";		
		this.sem[0] = "efestiu.dias0";
		this.sem[1] = "efestiu.dias1";
		this.sem[2] = "efestiu.dias2";
		this.sem[3] = "efestiu.dias3";
		this.sem[4] = "efestiu.dias4";
		this.sem[5] = "efestiu.dias5";
		this.sem[6] = "efestiu.dias6";
		this.sem[7] = "efestiu.dias7";
	}
	
	public Boolean validation() {
		if (fdataini == null) {
			addActionError(getText("eturnos.error.1"));
			return false;			
		}
		if (fdatafin == null) {
			addActionError(getText("eturnos.error.2"));
			return false;			
		}
		if (fdataini.after(fdatafin)) {
			addActionError(getText("eturnos.error.3"));
			return false;
		}
		if (linkCalendari.check(getId(), new java.sql.Date(fdataini.getTime()),new java.sql.Date(fdatafin.getTime())) != 0) {
			addActionError(getText("eturnos.error.4"));
			return false;						
		}
		if (fttorn == null || fttorn.equals("0")) {
			addActionError(getText("eturnos.error.5"));
			return false;			
		}
		return true;
	}
	public Boolean validationMod() {
		if (fdatafin == null) {
			addActionError(getText("eturnos.error.2"));
			return false;			
		}
		if (fdataini.after(fdatafin)) {
			addActionError(getText("eturnos.error.3"));
			return false;
		}
		if (linkCalendari.check(getId(), new java.sql.Date(fdataini.getTime()),new java.sql.Date(fdatafin.getTime())) != 1) {
			addActionError(getText("eturnos.error.4"));
			return false;						
		}
		if (fttorn == null || fttorn.equals("0")) {
			addActionError(getText("eturnos.error.5"));
			return false;			
		}
		return true;
	}
}
