package tornodrom.view;

import java.sql.Timestamp;
import java.util.Calendar;
import java.util.List;
import java.util.Map;

import org.hibernate.exception.JDBCConnectionException;

import tornodrom.control.MenuManager;
import tornodrom.control.UsuariManager;
import tornodrom.model.Perfils;
import tornodrom.model.Usuaris;
import tornodrom.model.Menus;

import com.opensymphony.xwork2.ActionContext;
import com.opensymphony.xwork2.ActionSupport;

public class LoginAction extends ActionSupport {

	private String usuari = null;
	private String claudpas = null;
	private String claudpas1 = null;
	private String claudpas2 = null;	
	private Usuaris user = null;
	private String usuconect= null;
	private Perfils perfil = null;
	private String tperfil= null;

	private String menu= null;
	
	private UsuariManager linkController;	
	private MenuManager linkMenu;
	private List<Menus> menus;
	
	private Map session;

	public LoginAction() {
		linkController = new UsuariManager();
		linkMenu = new MenuManager();
		session = ActionContext.getContext().getSession();		
	}

	public String execute() {
		return SUCCESS;
	}

	public String find() {
		if (!autenticacio()) {
			return ERROR;
		}else{
			return SUCCESS;			
		}
	}

	public String change() {
		if (!autenticacio()) {
			return ERROR;
		}else{
			if (getClaudpas1().equals("") || getClaudpas1() == null) {
				addActionError(getText("chngpass.error.pwd.1"));
				return ERROR;
			}else if (getClaudpas2().equals("") || getClaudpas2() == null) {
				addActionError(getText("chngpass.error.pwd.2"));
				return ERROR;			
			} else if (! getClaudpas1().equals(getClaudpas2())){
				addActionError(getText("chngpass.error.pwd.3"));
				return ERROR;				
			} else if (getClaudpas1().equals(getClaudpas())){
				addActionError(getText("chngpass.error.pwd.4"));
				return ERROR;				
			}
			// Canvi password
			user = linkController.find(getUsuari());
			user.setClaudPas(getClaudpas1());
			user.setUsuariModi((String)session.get("xusuari"));
			user.setTmstmpModi(new Timestamp(Calendar.getInstance().getTime().getTime()));			
			linkController.update(user);
			return SUCCESS;			
		}
	}	
	
	public String getUsuari() {
		return usuari;
	}
	public String getClaudpas() {
		return claudpas;
	}
	public String getClaudpas1() {
		return claudpas1;
	}
	public String getClaudpas2() {
		return claudpas2;
	}
	public String getUsuconect() {
		return usuconect;
	}
	public String getTperfil() {
		return tperfil;
	}
	public String getMenu() {
		return menu;
	}
	
	public void setUsuari(String usuari) {
		this.usuari = usuari;
	}	
	public void setClaudpas(String claudpas) {
		this.claudpas = claudpas;
	}	
	public void setClaudpas1(String claudpas1) {
		this.claudpas1 = claudpas1;
	}
	public void setClaudpas2(String claudpas2) {
		this.claudpas2 = claudpas2;
	}
	public void setUser(Usuaris user) {
		this.user = user;
	}
	public void setUsuconect(String usuc) {
		this.usuconect = usuc;
	}	
	public void setTperfil(String per) {
		this.tperfil = per;
	}	

	public void setMenu(String men) {
		this.menu = men;
	}	
	public String creaMenu(int perfil) {
		this.menus = linkMenu.list(perfil);
		this.menu = "<ul id=\"nav\">\n ";
		int n = 0;
		n = menu(n);
		this.menu = this.menu + "</ul>";
		return this.menu;
	}
	
	private int menu (int nn) {
		for (int i=nn;i<this.menus.size();i++) {
			int tnivel = this.menus.get(i).getNivell();
			String tnom = this.menus.get(i).getNom();
			String tdest = this.menus.get(i).getTarget();

			if (tnivel == 1) {
				// Capalera nivell 1
				this.menu = this.menu + "<li class=\"top\">\n";					
			} else {
				// Capalera reste nivells
				this.menu = this.menu + "<li>\n";				
			}

			if (i < this.menus.size() - 1) {
				if (tnivel < this.menus.get(i + 1).getNivell()) {
					if (tnivel == 1) {
						// Linia nivell 1
						this.menu = this.menu + "<a id=\"" + getText(tnom) + 
									"\" class=\"top_link\"><span class=\"down\">" + getText(tnom) + 
									"</span></a>\n<ul class=\"sub\">";					
					} else {
						// Linia reste nivells
						this.menu = this.menu + "<a class=\"fly\">" + getText(tnom) + "</a>\n<ul>";						
					}
					i++;
					i = menu(i);
				} else {
					if (tnivel == 1) {
						// Linia nivell 1
						this.menu = this.menu +
						"<a href=\"" + tdest + "\" id=\"" + getText(tnom) + 
						"\" class=\"top_link\"><span>" + getText(tnom) + "</span></a>";
					} else {
						// Linia reste nivells					
						this.menu = this.menu +
						"<a href=\"" + tdest + "\">" + getText(tnom) + "</a>";
					}
				}
			} else {
				if (tnivel == 1) {
					// Linia nivell 1
					this.menu = this.menu +
					"<a href=\"" + tdest + "\" id=\"" + getText(tnom) + 
					"\" class=\"top_link\"><span>" + getText(tnom) + "</span></a>";
				} else {
					// Linia reste nivells					
					this.menu = this.menu +
					"<a href=\"" + tdest + "\">" + getText(tnom) + "</a>";
				}
			}
			// Peu nivells
			if (tdest == null) {
				this.menu = this.menu + "</ul>\n </li>\n";
			} else {
				this.menu = this.menu + "</li>\n";				
			}
			if (i < this.menus.size()- 1) {
				if (tnivel > this.menus.get(i + 1).getNivell()) return i;
			}
		}
		return nn;
	}
	
	public Boolean autenticacio () {
		if (getUsuari().equals("") || getUsuari() == null) {
			addActionError(getText("login.error.user.1"));
			return false;
		}else if (getClaudpas().equals("") || getClaudpas() == null) {
			addActionError(getText("login.error.user.2"));
			return false;			
		} else {
			try {
				this.user = linkController.find(getUsuari());
				if (null != this.user) {
					if (null != this.user.getDEmpleat().getDataBaixa()){
						addActionError(getText("login.error.user.7"));
						return false;							
					}
					if (getClaudpas().equals(this.user.getClaudPas())) {
//						String sal = getText("menu.userc");
						String usuc = this.user.getDEmpleat().getNom() + " " + 
							this.user.getDEmpleat().getPCognom();
						this.setUsuconect(usuc);
						this.setMenu(creaMenu(this.user.getDPerfil().getIdPerfil()));								

						Map session = ActionContext.getContext().getSession();
						session.put("xusuari", usuari);
						session.put("xmenu", menu);
						session.put("xnomusu", usuconect);
						session.put("xidempl", this.user.getDEmpleat().getIdEmpleat());
						return true;
					}else{
						addActionError(getText("login.error.user.4"));
						return false;	
					}
				} else { 
					addActionError(getText("login.error.user.3"));
					return false;
				}
			} catch (JDBCConnectionException e){
				addActionError(getText("login.error.user.5"));
				return false;
			}catch (Exception e){
				e.printStackTrace();
				addActionError(getText("login.error.user.6"));
				return false;
			}
		}		
	}
}
