package tornodrom.view;

import java.util.Date;
import java.sql.Time;
import java.sql.Timestamp;
import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.List;
import java.util.Map;

import tornodrom.control.TipuscalendariManager;
import tornodrom.list.TipusCalendarisTab;
import tornodrom.model.TipusCalendaris;

import com.opensymphony.xwork2.ActionContext;
import com.opensymphony.xwork2.ActionSupport;

public class PtcalenAction extends ActionSupport {

	private int id;
	
	private TipuscalendariManager linkTcalendari;
	private List<TipusCalendaris> ptcalendariList;
	ArrayList<TipusCalendarisTab> lista;
	private List ptcalendariDisp = new ArrayList();	

	private Map session;
	
	private TipusCalendaris tcalen;
	private String vttrndescr;
	
	public PtcalenAction() {
		linkTcalendari = new TipuscalendariManager();
		session = ActionContext.getContext().getSession();				
	}	
	
	public String execute() {
		return SUCCESS;
	}

	public String llista() {
		this.ptcalendariList = linkTcalendari.list();
		for (int iter = 0; iter < this.ptcalendariList.size(); iter++) {
			this.ptcalendariDisp.add(
					new TipusCalendarisTab(
							this.ptcalendariList.get(iter).getIdTCalendari(), 
							this.ptcalendariList.get(iter).getDescripcio(),
							"<a href=\"ptcalenM?id=" + this.ptcalendariList.get(iter).getIdTCalendari()
							+ "\">" + getText("ptcalen.label.upd") + "</a> | "
							+ "<a href=\"ptcalenD?id=" + this.ptcalendariList.get(iter).getIdTCalendari()
							+ "\">" + getText("ptcalen.label.del") + "</a>"
			));
		}
		return SUCCESS;
	}
	
	public String add() {
		if (validation()) {
			tcalen = new TipusCalendaris();
			tcalen.setDescripcio(getVttrndescr());
			tcalen.setUsuariAlta((String)session.get("xusuari"));
			tcalen.setTmstmpAlta(new Timestamp(Calendar.getInstance().getTime().getTime()));
			linkTcalendari.add(tcalen);
			return SUCCESS;
		} else {
			return ERROR;
		}
	}

	public String previous() {
		tcalen = linkTcalendari.find(getId());
		setVttrndescr(tcalen.getDescripcio());
		return SUCCESS;
	}	
	
	public String mod() {
		if (validation()) {
			tcalen = linkTcalendari.find(getId());
			tcalen.setDescripcio(getVttrndescr());
			tcalen.setUsuariModi((String)session.get("xusuari"));
			tcalen.setTmstmpModi(new Timestamp(Calendar.getInstance().getTime().getTime()));
			linkTcalendari.update(tcalen);
			return SUCCESS;
		} else {
			return ERROR;
		}
	}		

	public String del() {
		tcalen = linkTcalendari.find(getId());
		tcalen.setUsuariBaja((String)session.get("xusuari"));
		tcalen.setTmstmpBaja(new Timestamp(Calendar.getInstance().getTime().getTime()));
		linkTcalendari.delete(tcalen);
		return SUCCESS;
	}				
	
	public int getId () {
		return id;
	}
	public List<TipusCalendarisTab> getPtcalendariDisp() {
		return ptcalendariDisp;
	}	
	public String getVttrndescr(){
		return vttrndescr;
	}
	
	public void setId (int id){
		this.id = id;
	}
	public void setPtcalendariDisp(List<TipusCalendarisTab> ptcalendariDisp) {
		this.ptcalendariDisp = ptcalendariDisp;
	}	
	public void setVttrndescr (String vttrndescr) {
		this.vttrndescr = vttrndescr;
	}
	
	public Boolean validation() {
		if (getVttrndescr() == null || getVttrndescr().trim().equals("")) {
			addActionError(getText("ptcalen.error.1"));
			return false;
		}
		return true;
	}
}
