package tornodrom.view;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.List;
import java.util.Map;

import tornodrom.control.ConceptesManager;
import tornodrom.list.ConceptesTab;
import tornodrom.model.Conceptes;

import com.opensymphony.xwork2.ActionContext;
import com.opensymphony.xwork2.ActionSupport;

public class PtcncptAction extends ActionSupport {

	private int id;
	
	private ConceptesManager linkConcepte;
	private List<Conceptes> ptcncptList;
	ArrayList<ConceptesTab> lista;
	private List ptcncptDisp = new ArrayList();	

	private Map session;

	private Conceptes cncpt;
	private String vcncptnom;
	
	public PtcncptAction() {
		linkConcepte = new ConceptesManager();
		session = ActionContext.getContext().getSession();		
	}	
	
	public String execute() {
		return SUCCESS;
	}
	public String llista() {
		this.ptcncptList = linkConcepte.list();
		for (int iter = 0; iter < this.ptcncptList.size(); iter++) {
			this.ptcncptDisp.add(
					new ConceptesTab(
							this.ptcncptList.get(iter).getIdConcepte(), 
							this.ptcncptList.get(iter).getNom(),
							"<a href=\"ptcncptM?id=" + this.ptcncptList.get(iter).getIdConcepte()
							+ "\">" + getText("ptcncpt.label.upd") + "</a> | "
							+ "<a href=\"ptcncptD?id=" + this.ptcncptList.get(iter).getIdConcepte()
							+ "\">" + getText("ptcncpt.label.del") + "</a>"
			));
		}
		return SUCCESS;
	}
	public String add() {
		if (validation()) {
			cncpt = new Conceptes();
			cncpt.setNom(getVcncptnom());
			cncpt.setUsuariAlta((String)session.get("xusuari"));
			cncpt.setTmstmpAlta(new Timestamp(Calendar.getInstance().getTime().getTime()));
			linkConcepte.add(cncpt);
			return SUCCESS;
		} else {
			return ERROR;
		}
	}

	public String previous() {
		cncpt = linkConcepte.find(getId());
		setVcncptnom(cncpt.getNom());
		return SUCCESS;
	}
	
	public String mod() {
		if (validation()) {
			cncpt = linkConcepte.find(getId());
			cncpt.setNom(getVcncptnom());
			cncpt.setUsuariModi((String)session.get("xusuari"));
			cncpt.setTmstmpModi(new Timestamp(Calendar.getInstance().getTime().getTime()));
			linkConcepte.update(cncpt);
			return SUCCESS;
		} else {
			return ERROR;
		}
	}		

	public String del() {
		cncpt = linkConcepte.find(getId());
		cncpt.setUsuariBaja((String)session.get("xusuari"));
		cncpt.setTmstmpBaja(new Timestamp(Calendar.getInstance().getTime().getTime()));
		linkConcepte.delete(cncpt);
		return SUCCESS;
	}			
	
	public int getId () {
		return id;
	}
	public List<ConceptesTab> getPtcncptDisp() {
		return ptcncptDisp;
	}
	public String getVcncptnom () {
		return vcncptnom;
	}
	
	public void setId (int id){
		this.id = id;
	}
	public void setPtcncptDisp(List<ConceptesTab> ptcncptDisp) {
		this.ptcncptDisp = ptcncptDisp;
	}
	public void setVcncptnom (String vcncptnom) {
		this.vcncptnom = vcncptnom;
	}

	public Boolean validation() {
		if (getVcncptnom() == null || getVcncptnom().trim().equals("")) {
			addActionError(getText("ptcncpt.error.1"));
			return false;
		}
		return true;
	}
}
