package tornodrom.view;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.List;
import java.util.Map;

import tornodrom.control.TipusfestiuManager;
import tornodrom.list.TipusFestiusTab;
import tornodrom.model.TipusFestius;

import com.opensymphony.xwork2.ActionContext;
import com.opensymphony.xwork2.ActionSupport;

public class PtfestiAction extends ActionSupport {

	private int id;
	
	private TipusfestiuManager linkTfestiu;
	private List<TipusFestius> ptfestiList;
	ArrayList<TipusFestiusTab> lista;
	private List ptfestiDisp = new ArrayList();	

	private Map session;

	private TipusFestius tfestiu;
	private String vtfstdescr;
	private String vtfstcolor;
	private String hexmask = "0123456789abcdef";	
	
	public PtfestiAction() {
		linkTfestiu = new TipusfestiuManager();
		session = ActionContext.getContext().getSession();		
	}	
	
	public String execute() {
		return SUCCESS;
	}

	public String llista() {
		this.ptfestiList = linkTfestiu.list();
		for (int iter = 0; iter < this.ptfestiList.size(); iter++) {
			this.ptfestiDisp.add(
					new TipusFestiusTab(
							this.ptfestiList.get(iter).getIdTFestiu(), 
							this.ptfestiList.get(iter).getDescripcio(),
							this.ptfestiList.get(iter).getColor(),
							"<a href=\"ptfestiM?id=" + this.ptfestiList.get(iter).getIdTFestiu()
							+ "\">" + getText("ptfesti.label.upd") + "</a> | "
							+ "<a href=\"ptfestiD?id=" + this.ptfestiList.get(iter).getIdTFestiu()
							+ "\">" + getText("ptfesti.label.del") + "</a>"
			));
		}
		return SUCCESS;
	}
	
	public String add() {
		if (validation()) {
			tfestiu = new TipusFestius();
			tfestiu.setDescripcio(getVtfstdescr());
			tfestiu.setColor(getVtfstcolor().toUpperCase());
			tfestiu.setUsuariAlta((String)session.get("xusuari"));
			tfestiu.setTmstmpAlta(new Timestamp(Calendar.getInstance().getTime().getTime()));
			linkTfestiu.add(tfestiu);
			return SUCCESS;
		} else {
			return ERROR;
		}
	}

	public String previous() {
		tfestiu = linkTfestiu.find(getId());
		setVtfstdescr(tfestiu.getDescripcio());
		setVtfstcolor(tfestiu.getColor());
		return SUCCESS;
	}
	
	public String mod() {
		if (validation()) {
			tfestiu = linkTfestiu.find(getId());
			tfestiu.setDescripcio(getVtfstdescr());
			tfestiu.setColor(getVtfstcolor().toUpperCase());
			tfestiu.setUsuariModi((String)session.get("xusuari"));
			tfestiu.setTmstmpModi(new Timestamp(Calendar.getInstance().getTime().getTime()));
			linkTfestiu.update(tfestiu);
			return SUCCESS;
		} else {
			return ERROR;
		}
	}		

	public String del() {
		tfestiu = linkTfestiu.find(getId());
		tfestiu.setUsuariBaja((String)session.get("xusuari"));
		tfestiu.setTmstmpBaja(new Timestamp(Calendar.getInstance().getTime().getTime()));
		linkTfestiu.delete(tfestiu);
		return SUCCESS;
	}			
	
	public int getId () {
		return id;
	}
	public List<TipusFestiusTab> getPtfestiDisp() {
		return ptfestiDisp;
	}
	public String getVtfstdescr () {
		return vtfstdescr;
	}
	public String getVtfstcolor () {
		return vtfstcolor;
	}
	
	public void setId (int id){
		this.id = id;
	}
	public void setPtfestiDisp(List<TipusFestiusTab> ptfestiDisp) {
		this.ptfestiDisp = ptfestiDisp;
	}
	public void setVtfstdescr (String vtfstdescr) {
		this.vtfstdescr = vtfstdescr;
	}
	public void setVtfstcolor (String vtfstcolor) {
		this.vtfstcolor = vtfstcolor;
	}

	public Boolean validation() {
		if (getVtfstdescr() == null || getVtfstdescr().trim().equals("")) {
			addActionError(getText("ptfesti.error.1"));
			return false;
		}
		if (getVtfstcolor() == null || getVtfstcolor().trim().equals("")) {
			addActionError(getText("ptfesti.error.2"));
			return false;
		}
		Boolean chk = true;
		for (int i = 0; i < getVtfstcolor().length(); i++) {
			if (i == 0 &&  ! getVtfstcolor().substring(i,i+1).equals("#"))  chk = false;
			if (i > 0 && hexmask.indexOf(getVtfstcolor().toLowerCase().substring(i,i+1)) < 0) chk = false;
		}
		if (!chk) addActionError(getText("ptfesti.error.3"));
		return chk;
	}
}
