package tornodrom.view;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.List;
import java.util.Map;

import tornodrom.control.TipusincidenciaManager;
import tornodrom.list.TipusIncidenciesTab;
import tornodrom.model.TipusIncidencies;

import com.opensymphony.xwork2.ActionContext;
import com.opensymphony.xwork2.ActionSupport;

public class PtincidAction extends ActionSupport {

	private int id;
	
	private TipusincidenciaManager linkTincidencia;
	private List<TipusIncidencies> ptincidList;
	ArrayList<TipusIncidenciesTab> lista;
	private List ptincidDisp = new ArrayList();	

	private Map session;

	private TipusIncidencies tincid;	
	private String vtincdescr;
	private Boolean vtincdia;
	
	public PtincidAction() {
		linkTincidencia = new TipusincidenciaManager();
		session = ActionContext.getContext().getSession();				
	}	
	
	public String execute() {
		return SUCCESS;
	}

	public String llista() {
		this.ptincidList = linkTincidencia.list();
		for (int iter = 0; iter < this.ptincidList.size(); iter++) {
			this.ptincidDisp.add(
					new TipusIncidenciesTab(
							this.ptincidList.get(iter).getIdTIncidencia(), 
							this.ptincidList.get(iter).getDescripcio(),
							this.ptincidList.get(iter).getDia(),
							"<a href=\"ptincidM?id=" + this.ptincidList.get(iter).getIdTIncidencia()
							+ "\">" + getText("ptincid.label.upd") + "</a> | "
							+ "<a href=\"ptincidD?id=" + this.ptincidList.get(iter).getIdTIncidencia()
							+ "\">" + getText("ptincid.label.del") + "</a>"
			));
		}
		return SUCCESS;
	}	
	
	public String add() {
		if (validation()) {
			tincid = new TipusIncidencies();
			tincid.setDescripcio(getVtincdescr());
			tincid.setDia(getVtincdia());
			tincid.setUsuariAlta((String)session.get("xusuari"));
			tincid.setTmstmpAlta(new Timestamp(Calendar.getInstance().getTime().getTime()));
			linkTincidencia.add(tincid);
			return SUCCESS;
		} else {
			return ERROR;
		}
	}

	public String previous() {
		tincid = linkTincidencia.find(getId());
		setVtincdescr(tincid.getDescripcio());
		setVtincdia(tincid.getDia());
		return SUCCESS;
	}
	
	public String mod() {
		if (validation()) {
			tincid = linkTincidencia.find(getId());
			tincid.setDescripcio(getVtincdescr());
			tincid.setDia(getVtincdia());
			tincid.setUsuariModi((String)session.get("xusuari"));
			tincid.setTmstmpModi(new Timestamp(Calendar.getInstance().getTime().getTime()));
			linkTincidencia.update(tincid);
			return SUCCESS;
		} else {
			return ERROR;
		}
	}		

	public String del() {
		tincid = linkTincidencia.find(getId());
		tincid.setUsuariBaja((String)session.get("xusuari"));
		tincid.setTmstmpBaja(new Timestamp(Calendar.getInstance().getTime().getTime()));
		linkTincidencia.delete(tincid);
		return SUCCESS;
	}				

	public int getId () {
		return id;
	}
	public List<TipusIncidenciesTab> getPtincidDisp() {
		return ptincidDisp;
	}
	public String getVtincdescr () {
		return vtincdescr;
	}
	public Boolean getVtincdia () {
		return vtincdia;
	}	
	
	public void setId (int id){
		this.id = id;
	}
	public void setPtincidDisp(List<TipusIncidenciesTab> ptincidDisp) {
		this.ptincidDisp = ptincidDisp;
	}
	public void setVtincdescr (String vtincdescr) {
		this.vtincdescr = vtincdescr;
	}
	public void setVtincdia (Boolean vtincdia) {
		this.vtincdia = vtincdia;
	}	
	
	public Boolean validation() {
		if (getVtincdescr() == null || getVtincdescr().trim().equals("")) {
			addActionError(getText("ptincid.error.1"));
			return false;
		}
		return true;
	}
}
