package tornodrom.view;

import java.util.Date;
import java.sql.Time;
import java.sql.Timestamp;
import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.List;
import java.util.Map;

import tornodrom.control.TipustornManager;
import tornodrom.list.TipusIncidenciesTab;
import tornodrom.list.TipusTornsTab;
import tornodrom.model.TipusTorns;

import com.opensymphony.xwork2.ActionContext;
import com.opensymphony.xwork2.ActionSupport;

public class PtturnoAction extends ActionSupport {

	private int id;
	
	private TipustornManager linkTtorn;
	private List<TipusTorns> ptturnoList;
	ArrayList<TipusTornsTab> lista;
	private List ptturnoDisp = new ArrayList();	

	private Map session;
	
	private TipusTorns ttorn;
	private String vttrndescr;
	private String vttrnhini;
	private String vttrnhfin;
	private String vttrncolor;
	private String hexmask = "0123456789abcdef";
	
	public PtturnoAction() {
		linkTtorn = new TipustornManager();
		session = ActionContext.getContext().getSession();				
	}	
	
	public String execute() {
		return SUCCESS;
	}

	public String llista() {
		this.ptturnoList = linkTtorn.list();
		for (int iter = 0; iter < this.ptturnoList.size(); iter++) {
			this.ptturnoDisp.add(
					new TipusTornsTab(
							this.ptturnoList.get(iter).getIdTTorn(), 
							this.ptturnoList.get(iter).getDescripcio(),
							this.ptturnoList.get(iter).getColor(),
							this.ptturnoList.get(iter).getHoraInici(),
							this.ptturnoList.get(iter).getHoraFi(),
							"<a href=\"ptturnoM?id=" + this.ptturnoList.get(iter).getIdTTorn()
							+ "\">" + getText("ptturno.label.upd") + "</a> | "
							+ "<a href=\"ptturnoD?id=" + this.ptturnoList.get(iter).getIdTTorn()
							+ "\">" + getText("ptturno.label.del") + "</a>"
			));
		}
		return SUCCESS;
	}
	
	public String add() {
		if (validation()) {
			ttorn = new TipusTorns();
			ttorn.setDescripcio(getVttrndescr());
			ttorn.setHoraInici(Time.valueOf(getVttrnhini()));
			ttorn.setHoraFi(Time.valueOf(getVttrnhfin()));
			ttorn.setColor(getVttrncolor().toUpperCase());
			ttorn.setUsuariAlta((String)session.get("xusuari"));
			ttorn.setTmstmpAlta(new Timestamp(Calendar.getInstance().getTime().getTime()));
			linkTtorn.add(ttorn);
			return SUCCESS;
		} else {
			return ERROR;
		}
	}

	public String previous() {
		ttorn = linkTtorn.find(getId());
		setVttrndescr(ttorn.getDescripcio());
		setVttrnhini(ttorn.getHoraInici().toString());
		setVttrnhfin(ttorn.getHoraFi().toString());
		setVttrncolor(ttorn.getColor());
		return SUCCESS;
	}	
	
	public String mod() {
		if (validation()) {
			ttorn = linkTtorn.find(getId());
			ttorn.setDescripcio(getVttrndescr());
			ttorn.setHoraInici(Time.valueOf(getVttrnhini()));
			ttorn.setHoraFi(Time.valueOf(getVttrnhfin()));
			ttorn.setColor(getVttrncolor().toUpperCase());
			ttorn.setUsuariModi((String)session.get("xusuari"));
			ttorn.setTmstmpModi(new Timestamp(Calendar.getInstance().getTime().getTime()));
			linkTtorn.update(ttorn);
			return SUCCESS;
		} else {
			return ERROR;
		}
	}		

	public String del() {
		ttorn = linkTtorn.find(getId());
		ttorn.setUsuariBaja((String)session.get("xusuari"));
		ttorn.setTmstmpBaja(new Timestamp(Calendar.getInstance().getTime().getTime()));
		linkTtorn.delete(ttorn);
		return SUCCESS;
	}				
	
	public int getId () {
		return id;
	}
	public List<TipusTornsTab> getPtturnoDisp() {
		return ptturnoDisp;
	}	
	public String getVttrndescr(){
		return vttrndescr;
	}
	public String getVttrnhini(){
		return vttrnhini;
	}
	public String getVttrnhfin(){
		return vttrnhfin;
	}	
	public String getVttrncolor(){
		return vttrncolor;
	}
	
	public void setId (int id){
		this.id = id;
	}
	public void setPtturnoDisp(List<TipusTornsTab> ptturnoDisp) {
		this.ptturnoDisp = ptturnoDisp;
	}	
	public void setVttrndescr (String vttrndescr) {
		this.vttrndescr = vttrndescr;
	}
	public void setVttrnhini (String vttrnhini) {
		this.vttrnhini = vttrnhini;
	}
	public void setVttrnhfin (String vttrnhfin) {
		this.vttrnhfin = vttrnhfin;
	}
	public void setVttrncolor (String vttrncolor) {
		this.vttrncolor = vttrncolor;
	}
	
	public Boolean validation() {
		if (getVttrndescr() == null || getVttrndescr().trim().equals("")) {
			addActionError(getText("ptturno.error.1"));
			return false;
		}
		try {
			Time tm = Time.valueOf(getVttrnhini());
		} catch (Exception e) {
			// TODO Auto-generated catch block
			addActionError(getText("ptturno.error.4"));
			return false;
		}
		try {
			Time tm = Time.valueOf(getVttrnhfin());
		} catch (Exception e) {
			// TODO Auto-generated catch block
			addActionError(getText("ptturno.error.5"));
			return false;
		}
		if (getVttrncolor() == null || getVttrncolor().trim().equals("")) {
			addActionError(getText("ptturno.error.2"));
			return false;
		}
		Boolean chk = true;
		for (int i = 0; i < getVttrncolor().length(); i++) {
			if (i == 0 &&  ! getVttrncolor().substring(i,i+1).equals("#"))  chk = false;
			if (i > 0 && hexmask.indexOf(getVttrncolor().toLowerCase().substring(i,i+1)) < 0) chk = false;
		}
		if (!chk) {
			addActionError(getText("ptturno.error.3"));
			return chk;
		}
		return true;
	}
}
